class DialogBox
{
	static MainPaddingTopBottom := 26
		, MainPaddingLeft := 12
		, ButtonBarPaddingTop := 12
		, ButtonBarPaddingRight := 9
		, ButtonWidth := 88
		, ButtonHeight := 26
		, ButtonOffset := 31
		, GuiMinWidth := 138
		, ControlsHeight := 0
		, GuiFont := {}
	
	InitGui(Title)
	{
		global DialogHwnd
		Gui, +Disabled
		Gui, New, HwndDlgH, % Title
		Gui, %DlgH%:Default
		if not DialogHwnd.HasKey(DlgH) {
			DialogHwnd[DlgH] := this.__Class
		}
		Gui, Color, FFFFFF
		Gui, Font, % this.GuiFontOptions, % this.GuiFont.Name
		Gui, +Owner1 +LastFound +ToolWindow -MinimizeBox -MaximizeBox
	}
	
	AddButtonBar(Buttons*)
	{
		Gui, Add, Progress, % "x0 y" this.ButtonBarY " w" this.GuiWidth " h" this.ButtonBarHeight " BackgroundDefault Disabled"
		ButtonY := this.ButtonBarY + this.ButtonBarPaddingTop
		ButtonCountDown := Buttons.Length()
		for key, item in Buttons {
			ButtonX := this.GuiWidth - this.ButtonBarPaddingRight * ButtonCountDown - this.ButtonWidth * ButtonCountDown + 1
			Gui, Add, Button
				, % "x" ButtonX " y" ButtonY " w" this.ButtonWidth " h" this.ButtonHeight
					. ((item.Action) ? " g" item.Action : "")
					. ((item.Default) ? " Default" : "")
				, % item.Name
			ButtonCountDown -= 1
		}
	}
	
	ShowGui()
	{
		Gui, Show, % "w" this.GuiWidth " h" this.GuiHeight
		Gui, -ToolWindow
	}
	
	CloseGui()
	{
		Transformer.Reset()
		Gui, 1:-Disabled
		Gui, Destroy
		Gui, 1:Default
	}
	
	ButtonBarHeight[]
	{
		get {
			return this.ButtonHeight + 2 * this.ButtonBarPaddingTop + 3
		}
	}
	
	ButtonBarY[]
	{
		get {
			return this.ControlsHeight + this.MainPaddingTopBottom
		}
	}
	
	GuiHeight[]
	{
		get {
			return this.ControlsHeight + this.MainPaddingTopBottom + this.ButtonBarHeight
		}
	}
	
	GuiWidth[]
	{
		get {
			return this.GuiMinWidth
		}
		set {
			NewGuiWidth := value + this.MainPaddingLeft + this.ButtonOffset + this.ButtonBarPaddingRight
			if (NewGuiWidth > this.GuiMinWidth) {
				this.GuiMinWidth := NewGuiWidth
			}
			return this.GuiMinWidth
		}
	}
	
	GuiFontOptions[]
	{
		get {
			static NCM_Size := 40 + 5*(A_IsUnicode ? 92 : 60)
				, MsgFont_Offset := 40 + 4*(A_IsUnicode ? 92 : 60)
			if not this.GuiFont.Name {
				VarSetCapacity(NCM, NCM_Size, 0)
				NumPut(NCM_Size, &NCM, 0, "UInt")
				if !DllCall("SystemParametersInfo", "UInt", 0x0029, "UInt", NCM_Size, "Ptr", &NCM, "UInt", 0) {
					return false
				}
				this.GuiFont.Name := StrGet(&NCM + MsgFont_Offset + 28, 32)
				Height := NumGet(&NCM + MsgFont_Offset, "Int")
				this.GuiFont.Size := DllCall("MulDiv", "Int", -Height, "Int", 72, "Int", A_ScreenDPI)
				this.GuiFont.Weight := NumGet(&NCM + MsgFont_Offset + 16, "Int")
				this.GuiFont.IsItalic := NumGet(&NCM + MsgFont_Offset + 20, "UChar")
			}
			return "s" this.GuiFont.Size " w" this.GuiFont.Weight ((this.GuiFont.IsItalic) ? " italic" : "")
		}
	}
}