class Event
{
	/**
	 * Tab 1 (XT) & Tab 2 (X2V)
	 */

	;* Input folder (%X%Folder)

	FolderButton()
	{	
		T := (A_GuiControl = "XtFolderButton") ? "Xt" : "X2v"
		Gui, +OwnDialogs
		SelectionMode := Config.XliffSelectionMode
		if (SelectionMode = "Files") {
			FileSelectFile, ItemList, M,
				, % Txt.Get("SelectXliffFilesPrompt")
				, XLIFF (*.xlf; *.xliff)
			if (ItemList) {
				Selection := {}
				Loop, Parse, ItemList, `n
				{
					if (Folder) {
						Selection[A_LoopField] := 1
						continue
					}
					Folder := A_LoopField
				}
			}
		} else {
			FileSelectFolder, Folder,, 0
				, % Txt.Get("SelectXliffFolderPrompt")
			if Folder and not FileExist(Folder "\*.xlf") and not FileExist(Folder "\*.xliff") {
				Folder := false
				MsgBox, 8208, % Txt.Get("NoXliffFilesMsgBoxTitle")
					, % Txt.Get("NoXliffFilesMsgBoxText")
			} else {
				Selection := 0
			}
		}
		if (Folder) {
			Adapter.FolderSelectionToXliffInput(T, Folder, Selection)
			Adapter.SetXliffControlsByXliff(T)
			if not (SelectionMode = "FileNameScheme") {
				Adapter.SetControlsByXliff(T)
			}
		}
	}

	/**
	 * Tab 1: XLIFF Tools
	 */

	;* XLIFF file set

	XtXliffDropDown()
	{
		Input.XliffSelection["Xt"] := XGui.XtXliffDropDown
	}

	;* Consistency check

	XtConsistencyButton()
	{
		Input.XliffConsistencyReport("Xt")
	}
	
	;* Source language
	
	XtExtractSourceRadio()
	{
		XGui.XtExtractSource["Show"] := 1
		XGui.XtRefreshSource["Show"] := 0
		XGui.XtExchangeSource["Show"] := 0
	}
	
	XtRefreshSourceRadio()
	{
		XGui.XtExtractSource["Show"] := 0
		XGui.XtRefreshSource["Show"] := 1
		XGui.XtExchangeSource["Show"] := 0
	}
	
	XtExchangeSourceRadio()
	{
		XGui.XtExtractSource["Show"] := 0
		XGui.XtRefreshSource["Show"] := 0
		XGui.XtExchangeSource["Show"] := 1
	}
	
	XtExtractSourceDropDown()
	{
		if (XGui.XtExtractSourceDropDown) {
			XGui.XtExtractSourceButton := 1
		} else {
			XGui.XtExtractSourceButton := 0
		}
	}

	XtExtractSourceButton()
	{
		Transformer.Settings.Mode := "ExtractSource"
		Transformer.Settings.Parameter.targetLanguage := XGui.XtExtractSourceDropDown
		SaveXliffDialog.Box()
	}
	
	
	XtRefreshSourceFromTargetCheckBox()
	{
		if (XGui.XtRefreshSourceFromTargetCheckBox) {
			XGui.XtRefreshSourceFromTargetCheckBox["Color"] := false
			XGui.XtRefreshSourceFromTargetDropDown["Enable"] := 1
			XGui.XtRefreshSourceFromTargetDropDown["Choose"] := 1
			XGui.XtRefreshSourceFromTargetDropDown["Focus"] := 1
		} else {
			XGui.XtRefreshSourceFromTargetCheckBox["Color"] := 808080
			XGui.XtRefreshSourceFromTargetDropDown["Enable"] := 0
			XGui.XtRefreshSourceFromTargetDropDown["Choose"] := false
			XGui.XtRefreshSourceButton["Focus"] := 1
		}
	}
	
	XtRefreshSourceButton()
	{
		FromTargetLang := XGui.XtRefreshSourceFromTargetCheckBox
		Transformer.Settings.Mode := "RefreshSource"
		if FromTargetLang {
			Transformer.Settings.Parameter.fromTargetLanguage := XGui.XtRefreshSourceFromTargetDropDown
		}
		SaveXliffDialog.Box()
	}
	
	XtExchangeSourceTargetDropDown()
	{
		if (XGui.XtExchangeSourceTargetDropDown) {
			XGui.XtExchangeSourceButton := 1
		} else {
			XGui.XtExchangeSourceButton := 0
		}
	}
	
	XtExchangeSourceButton()
	{
		Transformer.Settings.Mode := "ExchangeSource"
		Transformer.Settings.Parameter.withTargetLanguage := XGui.XtExchangeSourceTargetDropDown
		SaveXliffDialog.Box()
	}

	;* Create translation

	XtTargetLangEdit()
	{
		TargetLang := XGui.XtTargetLangEdit
		if (FoundPos := RegExMatch(TargetLang, "[^a-zA-Z0-9_-]")) {
			TargetLang := RegExReplace(TargetLang, "[^a-zA-Z0-9_-]", "")
			XGui.XtTargetLangEdit := TargetLang
			SendInput, % "{Right " FoundPos - 1 "}"
		}
		if (TargetLang) {
			Exclude := Input.XliffTargetLanguageKeys["Xt"]
			Exclude[Input.XliffSourceLanguage["Xt"]] := 1
			if not Exclude.HasKey(TargetLang) {
				XGui.XtTargetLangButton := 1
				return
			}
		}
		XGui.XtTargetLangButton := 0
	}

	XtTargetLangButton()
	{
		Transformer.Settings.Mode := "TargetLang"
		Transformer.Settings.Parameter.targetLanguage := XGui.XtTargetLangEdit
		SaveXliffDialog.Box()
	}
	
	;* Split / merge XLIFF
	
	XtSplitButton()
	{
		Transformer.Settings.Mode := "Split"
		SaveXliffDialog.Box()
	}
	
	XtMergeButton()
	{
		Transformer.Settings.Mode := "Merge"
		SaveXliffDialog.Box()
	}

	/**
	 * Tab 2: XLIFF to Illustrator variable library
	 */

	;* XLIFF file set

	X2vXliffDropDown()
	{
		Input.XliffSelection["X2v"] := XGui.X2vXliffDropDown
	}

	;* Transformation settings
	
	X2vSourceLangDataSetEdit()
	{
		global LostFocusControl
		Handle := XGui.HWND.X2vSourceLangDataSetEdit
		LostFocusControl[Handle] := "X2vSourceLangDataSetEditFocusLost"
	}
	
	X2vAllTargetLangRadio()
	{
		XGui.X2vListView["Enable"] := 0
		XGui.SourceEditReplaceDouble("X2v")
	}
	
	X2vChooseTargetLangRadio()
	{
		XGui.X2vListView["Enable"] := 1
		XGui.ListViewReplaceDoubles("X2v")
	}

	X2vButton()
	{
		Transformer.Settings.Mode := "X2v"
		Transformer.Settings.Parameter.sourceLanguageDataSet := XGui.X2vSourceLangDataSetEdit
		if XGui.X2vChooseTargetLangRadio {
			Input.X2v.List["Merge"] := XGui.X2vListView
			Transformer.Settings.Parameter.targetLanguageDataSets := Input.X2v.List["ParameterString"]
		} else {
			Transformer.Settings.Parameter.allTargetLanguageDataSets := true
		}
		SaveVarDialog.Box()
	}

	/**
	 * Tab 3: XLIFF from Illustrator variable library
	 */

	;* Input file

	V2xFileButton()
	{
		Gui, +OwnDialogs
		FileSelectFile, File,,
			, % Txt.Get("SelectVariableLibraryFilePrompt")
			, XML-Dateien (*.xml)
		if (File) {
			Input.AiVariablesFile := File
			Adapter.SetControlsByAiVariables()
		}
	}

	;* Extraction settings
	
	V2xSourceLangEdit()
	{
		global LostFocusControl
		Handle := XGui.HWND.V2xSourceLangEdit
		if not LostFocusControl.HasKey(Handle) {
			LostFocusControl[Handle] := "V2xSourceLangEditFocusLost"
		}
		EditText := XGui.V2xSourceLangEdit
		if (FoundPos := RegExMatch(EditText, "[^a-zA-Z0-9_-]")) {
			EditText := RegExReplace(EditText, "[^a-zA-Z0-9_-]", "")
			XGui.V2xSourceLangEdit := EditText
			SendInput, % "{Right " FoundPos - 1 "}"
		}
	}
	
	V2xSourceLangDataSetDropDown()
	{
		Selection := XGui.V2xSourceLangDataSetDropDown
		XGui.V2xSourceLangEdit := RegExReplace(Selection, "[^a-zA-Z0-9_-]", "", ReplaceCount)
		Input.V2x.List["Merge"] := XGui.V2xListView
		XGui.V2xListView := Input.V2x.List["Object", Selection]
		if ReplaceCount {
			MsgBox, 8256, % Txt.Get("V2xSourceLanguageReplacedMsgBoxTitle")
				, % Txt.Get("V2xSourceLanguageReplacedMsgBoxText")
			XGui.V2xSourceLangEdit["Focus"] := 0
		}
	}
	
	V2xAllTargetLangRadio()
	{
		XGui.V2xListView["Enable"] := 0
		XGui.SourceEditReplaceDouble("V2x")
	}
	
	V2xChooseTargetLangRadio()
	{
		XGui.V2xListView["Enable"] := 1
		XGui.ListViewReplaceDoubles("V2x")
	}

	V2xButton()
	{
		Transformer.Settings.Mode := "V2x"
		SourceLang := XGui.V2xSourceLangEdit
		SourceLangDataSet := XGui.V2xSourceLangDataSetDropDown
		Transformer.Settings.Parameter.sourceLanguage := (SourceLang != SourceLangDataSet)
			? SourceLang "" SourceLangDataSet
			: SourceLang
		if XGui.V2xChooseTargetLangRadio {
			Input.V2x.List["Merge"] := XGui.V2xListView
			Transformer.Settings.Parameter.targetLanguageSelection := Input.V2x.List["ParameterString"]
		} else {
			Transformer.Settings.Parameter.allTargetLanguages := true
		}
		SaveXliffDialog.Box()
	}
}

;* Functions for ListView-gLabel (Object Methods wouldnt work properly)

X2vListViewEvent()
{
	if (A_GuiEvent = "DoubleClick") {
		SendInput, {F2}
	} else if (A_GuiEvent = "e") {
		AddReplaceKey := XGui.X2vSourceLangDataSetEdit
		XGui.ListViewReplaceDoublesInRow("X2v", A_EventInfo, AddReplaceKey)
	}
}

V2xListViewEvent()
{
	if (A_GuiEvent = "DoubleClick") {
		SendInput, {F2}
	} else if (A_GuiEvent = "e") {
		AddReplaceKey := XGui.V2xSourceLangEdit
		XGui.ListViewReplaceDoublesInRow("V2x", A_EventInfo, AddReplaceKey)
	}
}

;* Functions that are called from OnMessage-Functions (Object Methods wouldnt work)

X2vSourceLangDataSetEditFocusLost()
{
	global LostFocusControl
	SetFormat, IntegerFast, D
	XGui.SourceEditReplaceDouble("X2v")
	LostFocusControl.Delete(XGui.HWND.X2vSourceLangDataSetEdit)
	return
}

V2xSourceLangEditFocusLost()
{
	global LostFocusControl
	SetFormat, IntegerFast, D
	XGui.SourceEditReplaceDouble("V2x")
	LostFocusControl.Delete(XGui.HWND.V2xSourceLangEdit)
	return
}

GuiClose:
WinHwnd := WinExist("Ahk_PID " DllCall("GetCurrentProcessId"))
if DialogHwnd.HasKey(WinHwnd) {
	OnMessage(0x201, "")
	ClassName := DialogHwnd[WinHwnd]
	%ClassName%.CloseGui()
} else {
	ExitApp
}
return
