class Input {
	
	static Xt := false
		, X2v := false
		, XL := false
		, V2x := false
	
	Init()
	{
		global SchemaCache := ComObjCreate("MSXML2.XMLSchemaCache.6.0")
			, XfCollectionToDocumentsXslt := ComObjCreate("MSXML2.FreeThreadedDOMDocument.6.0")
			, XfCollectionToConsistencyXslt := ComObjCreate("MSXML2.FreeThreadedDOMDocument.6.0")
			, XfConsistencyXliffDoc := ComObjCreate("MSXML2.DOMDocument.6.0")
			, XfConsistencyReportLanguageCode := "en"
			, XfConsistencyReportSourceToReportXslt := ComObjCreate("MSXML2.FreeThreadedDOMDocument.6.0")
			, XfCollectionToXliffXslt := ComObjCreate("MSXML2.FreeThreadedDOMDocument.6.0")
		
		XsltFolder := Config.Folder["Xslt"]
		
		SchemaCache.add("urn:oasis:names:tc:xliff:document:1.2", A_ScriptDir "\xsd\xliff-core-1.2-strict.xsd")
		SchemaCache.add("xl:ffer", A_ScriptDir "\xsd\xliffer.xsd")
		
		XfCollectionToDocumentsXslt.async := false
		XfCollectionToDocumentsXslt.load(XsltFolder "\xf-collection-to-documents.xsl")
		
		XfCollectionToConsistencyXslt.async := false
		XfCollectionToConsistencyXslt.load(XsltFolder "\xf-collection-to-consistency.xsl")
		
		XlifferLanguage := Config.Language
		
		XfConsistencyXliffDoc.async := false
		XfConsistencyXliffDoc.validateOnParse := false
		XfConsistencyXliffDoc.setProperty("SelectionNamespaces", "xmlns:xlf='urn:oasis:names:tc:xliff:document:1.2'")
		Loop, Files, % A_ScriptDir "\language\*xf-consistency.*"
		{
			if (A_LoopFileExt = "xlf" or A_LoopFileExt = "xliff") {
				XfConsistencyXliffDoc.load(A_LoopFileLongPath)
				FileNodes := XfConsistencyXliffDoc.selectNodes("/xlf:xliff/xlf:file[@original='xf-consistency.xsl']")
				for item in FileNodes
				{
					SourceLang := ""
					, TargetLang := ""
					SourceLangNode := item.selectSingleNode("@source-language")
					if IsObject(SourceLangNode) {
						SourceLang := SourceLangNode.Text
					}
					TargetLangNode := item.selectSingleNode("@target-language")
					if IsObject(TargetLangNode) {
						TargetLang := TargetLangNode.Text
					}
					if (SourceLang = XlifferLanguage and not TargetLang or TargetLang = XlifferLanguage) {
						XfConsistencyReportLanguageCode := XlifferLanguage
						break 2
					}
				}
			}
		}
		if (XfConsistencyReportLanguageCode != XlifferLanguage) {
			XfConsistencyXliffDoc.load(A_ScriptDir "\language\xf-consistency.xlf")
		}
		
		XfConsistencyReportSourceToReportXslt.async := false
		XfConsistencyReportSourceToReportXslt.load(XsltFolder "\xf-consistency-report-source-to-report.xsl")
		
		XfCollectionToXliffXslt.async := false
		XfCollectionToXliffXslt.load(XsltFolder "\xf-collection-to-xliff.xsl")
	}
	
	XliffFolder[X]
	{
		get {
			this.Linked(X)
			return this[X].Folder
		}
		set {
			this.Linked(X)
			this[X] := ""
			this[X] := new XliffInput
			this[X].Folder := value
		}
	}
	
	XliffFile[X]
	{
		set {
			this.Linked(X)
			this[X].File := value
		}
	}
	
	XliffSelection[T]
	{
		set {
			if (Config.XliffSelectionMode = "FileNameScheme" and (T = "Xt" or T = "X2v" or T = "XL")) {
				X := T
				this.Linked(X)
				if (value != this[X].XSelection) {
					this[X].Selection := value
					Adapter.SetControlsByXliff(T)
				}
			}
		}
	}
	
	XliffCollection(X)
	{
		this.Linked(X)
		this[X].XliffCollection()
	}
	
	XliffConsistencyReport(X)
	{
		this.Linked(X)
		this[X].ConsistencyReport()
	}
	
	XliffConsiderResult[X]
	{
		get {
			this.Linked(X)
			return this[X].Consider
		}
	}
	
	XliffTargetLanguageKeys[X]
	{
		get {
			this.Linked(X)
			return this[X].TargetLanguageKeys
		}
	}
	
	XliffSourceLanguage[X]
	{
		get {
			this.Linked(X)
			return this[X].SourceLanguage
		}
	}
	
	Linked(ByRef X)
	{
		if Config.XliffLinked and (X = "Xt" or X = "X2v") {
			X := "XL"
		}
	}
	
	LinkXliff(X := false)
	{
		if (X and IsObject(this[X])) {
			this.XL := this.DeepClone(this[X])
		} else {
			this.XL := new XliffInput
		}
		this.Xt := ""
		this.X2v := ""
	}
	
	DeepClone(IObj)
	{
		NObj := ObjClone(IObj)
		for k,v in NObj
        if IsObject(v)
            NObj[k] := this.DeepClone(v)
		return NObj
	}
	
	UnlinkXliff()
	{
		if IsObject(this.XL) {
			this.Xt := this.DeepClone(this.XL)
			this.X2v := this.DeepClone(this.XL)
		}
		this.XL := ""
	}
	
	XliffDropDownList[X]
	{
		get {
			this.Linked(X)
			if (Config.XliffSelectionMode = "FileNameScheme") {
				return this[X].BaseNameList
			} else {
				for fileName in this[X].Selection.File {
					if (A_Index > 1) {
						FileNameList .= "|"
					}
					FileNameList .= fileName
				}
				return FileNameList
			}
		}
	}
	
	XliffReset()
	{
		this.Xt := ""
		, this.X2v := ""
		, this.XL := ""
	}
	
	AiVariablesFile[]
	{
		set {
			this.V2x := ""
			this.V2x := new AiVariablesInput
			this.V2x.File := value
		}
	}
	
	Reset()
	{
		this.XliffReset()
		Input.V2x := ""
	}
}