class SaveVarDialog extends DialogBox
{
	static Hwnd := {}
		, DefaultFile
	
	Box()
	{
		global SaveVarFolderEdit
			, SaveVarFolderButton
			, CreateVisibilityVariablesCheckBox
			, SaveVarFileEdit
		X := (Config.XliffLinked) ? "XL" : "X2v"
		if IsObject(BaseName := Input[X].BaseName) {
			for b in BaseName {
				BaseNameOptions .= "|" b
			}
			this.DefaultFile := BaseNameOptions
		} else {
			this.DefaultFile := BaseName
		}
		this.InitGui(Txt.Get("SaveVarDialogTitle"))
		Gui, Add, Text, % "x" this.MainPaddingLeft " y" this.MainPaddingTopBottom " Section"
			, % Txt.Get("SaveVarDialogOutputFolder")
		Gui, Add, Edit, xp0 yp20 w333 h20 ReadOnly vSaveVarFolderEdit, % Input[X].Folder
		Gui, Add, Button, % "xp336 yp-1 w30 h22 vSaveVarFolderButton HwndOpenButton g" this.__Class ".FolderButton"
		GuiButtonIcon(OpenButton, "resources\folder-open.ico")
		this.GuiWidth := 350
		Gui, Font, bold
		Gui, Add, Text, xs0 yp38, % Txt.Get("SaveVarDialogSaveOptions")
		Gui, Font,
		Gui, Add, CheckBox, yp25 vCreateVisibilityVariablesCheckBox Checked
			, % Txt.Get("SaveVarDialogCreateVisibilityVariablesCheckBox")
		Gui, Add, Text, yp37, % Txt.Get("SaveVarDialogFileLabel")
		if BaseNameOptions {
			Gui, Add, ComboBox, % "xp0 yp20 w363 h20 vSaveVarFileEdit HwndH g" this.__Class ".FileEdit", % this.DefaultFile
		} else {
			Gui, Add, Edit, % "xp0 yp20 w363 h20 vSaveVarFileEdit HwndH g" this.__Class ".FileEdit", % this.DefaultFile
		}
		this.Hwnd.FileEdit := H
		GuiControlGet, ControlPos, Pos, SaveVarFileEdit
		this.ControlsHeight := ControlPosY + ControlPosH
		Buttons := [{Name: Txt.Get("DialogButtonOK"), Action: this.__Class ".OK", Default: 1}
			, {Name: Txt.Get("DialogButtonCancel"), Action: this.__Class ".Cancel"}]
		this.AddButtonBar(Buttons*)
		this.ShowGui()
	}
	
	FolderButton()
	{
		global SaveVarFolderEdit
		FileSelectFolder, Folder, % "*" SaveVarDialog.Folder, 1, % Txt.Get("SaveVarDialogSelectFolderPrompt")
		if Folder {
			GuiControl,, SaveVarFolderEdit, % Folder
		}
	}
	
	FileEdit()
	{
		global LostFocusControl
		Handle := SaveVarDialog.Hwnd.FileEdit
		LostFocusControl[Handle] := "SaveVarFileEditFocusLost"
	}
	
	OK()
	{
		global SaveVarFolderEdit
			, CreateVisibilityVariablesCheckBox
			, SaveVarFileEdit
		GuiControlGet, Folder,, SaveVarFolderEdit
		Transformer.Settings.Folder := Folder
		GuiControlGet, CreateVisibilityVariablesChecked,, CreateVisibilityVariablesCheckBox
		if CreateVisibilityVariablesChecked {
			Transformer.Settings.Parameter.addVisibilityVariables := true
		}
		GuiControlGet, File,, SaveVarFileEdit
		if (ExtFoundPos := RegExMatch(File, "i)\.xml$")) {
			File := SubStr(File, 1, ExtFoundPos -1)
		}
		File .= ".xml"
		Transformer.Settings.Output.File := File
		if (Transformer.Transform()) {
			MsgBox, 8256, % Txt.Get("SaveVarDialogDoneMsgBoxTitle")
				, % Txt.Get("SaveVarDialogDoneMsgBoxText")
		}
		base.CloseGui()
	}
	
	Cancel()
	{
		base.CloseGui()
	}
}

SaveVarFileEditFocusLost()
{
	global SaveVarFileEdit, LostFocusControl
	GuiControlGet, EditText,, SaveVarFileEdit
	if not EditText {
		GuiControl,, SaveVarFileEdit, % SaveVarDialog.DefaultFile
	}
	LostFocusControl.Delete(SaveVarDialog.Hwnd.FileEdit)
}