class TrayMenu {
	
	static ShowStandardAhkItems := 0
		, MenuItem := {}
	
	Init()
	{
		this.MenuItem := {XliffLinked: Txt.Get("TrayMenuXliffLinked")
			, XliffSelection: Txt.Get("TrayMenuXliffSelection")
			, XliffSelectionFileNameScheme: Txt.Get("TrayMenuXliffSelectionFileNameScheme")
			, XliffSelectionXliffFolder: Txt.Get("TrayMenuXliffSelectionXliffFolder")
			, XliffSelectionXliffFiles: Txt.Get("TrayMenuXliffSelectionXliffFiles")
			, LoadIni: Txt.Get("TrayMenuLoadSettings")
			, SaveIni: Txt.Get("TrayMenuSaveSettings")
			, LoadStandardIni: Txt.Get("TrayMenuLoadDefaultSettings")
			, SaveStandardIni: Txt.Get("TrayMenuSaveDefaultSettings")
			, ResetConfig: Txt.Get("TrayMenuResetSettings")
			, Exit: Txt.Get("TrayMenuExit")}
		
		if this.ShowStandardAhkItems {
			Menu, Tray, Add
		} else {
			Menu, Tray, NoStandard
		}
		Menu, Tray, Add, % this.MenuItem.XliffLinked, TrayMenuEvent.XliffLinked
		Menu, XliffSelection, Add, % this.MenuItem.XliffSelectionFileNameScheme, TrayMenuEvent.XliffSelectionFileNameScheme, +Radio
		Menu, XliffSelection, Add, % this.MenuItem.XliffSelectionXliffFolder, TrayMenuEvent.XliffSelectionXliffFolder, +Radio
		Menu, XliffSelection, Add, % this.MenuItem.XliffSelectionXliffFiles, TrayMenuEvent.XliffSelectionXliffFiles, +Radio
		
		XliffSelectionMode := Config.XliffSelectionMode
		if (XliffSelectionMode = "FileNameScheme") {
			Menu, XliffSelection, Check, % this.MenuItem.XliffSelectionFileNameScheme
		} else if (XliffSelectionMode = "Folder") {
			Menu, XliffSelection, Check, % this.MenuItem.XliffSelectionXliffFolder
		} else if (XliffSelectionMode = "Files") {
			Menu, XliffSelection, Check, % this.MenuItem.XliffSelectionXliffFiles
		}
		Menu, Tray, Add, % this.MenuItem.XliffSelection, :XliffSelection
		
		if Config.XliffLinked {
			Menu, Tray, Check, % this.MenuItem.XliffLinked
		}
		Menu, Tray, Add
		Menu, Tray, Add, % this.MenuItem.LoadIni, TrayMenuEvent.LoadIni
		if not Config.IniDropDownList {
			Menu, Tray, Disable, % this.MenuItem.LoadIni
		}
		Menu, Tray, Add, % this.MenuItem.SaveIni, TrayMenuEvent.SaveIni
		Menu, Tray, Add, % this.MenuItem.LoadStandardIni, TrayMenuEvent.LoadStandardIni
		if not Config.HasStandardIni {
			Menu, Tray, Disable, % this.MenuItem.LoadStandardIni
		}
		Menu, Tray, Add, % this.MenuItem.SaveStandardIni, TrayMenuEvent.SaveStandardIni
		Menu, Tray, Add, % this.MenuItem.ResetConfig, TrayMenuEvent.ResetConfig
		Menu, Tray, Add
		Menu, Tray, Add, % this.MenuItem.Exit, TrayMenuEvent.Exit
	}
	
	XliffLinked[]
	{
		set {
			Menu, Tray, % ((value) ? "Check" : "Uncheck")
				, % this.MenuItem.XliffLinked
		}
	}
	
	XliffSelectionFileNameScheme[]
	{
		set {
			if value {
				Menu, XliffSelection, Check, % TrayMenu.MenuItem.XliffSelectionFileNameScheme
				Menu, XliffSelection, Uncheck, % TrayMenu.MenuItem.XliffSelectionXliffFolder
				Menu, XliffSelection, Uncheck, % TrayMenu.MenuItem.XliffSelectionXliffFiles
			} else {
				Menu, XliffSelection, Uncheck, % TrayMenu.MenuItem.XliffSelectionFileNameScheme
				Menu, XliffSelection, Disable, % TrayMenu.MenuItem.XliffSelectionFileNameScheme
			}
		}
	}
	
	XliffSelectionXliffFolder[]
	{
		set {
			if value {
				Menu, XliffSelection, Uncheck, % TrayMenu.MenuItem.XliffSelectionFileNameScheme
				Menu, XliffSelection, Check, % TrayMenu.MenuItem.XliffSelectionXliffFolder
				Menu, XliffSelection, Uncheck, % TrayMenu.MenuItem.XliffSelectionXliffFiles
			} else {
				Menu, XliffSelection, Uncheck, % TrayMenu.MenuItem.XliffSelectionXliffFolder
				Menu, XliffSelection, Disable, % TrayMenu.MenuItem.XliffSelectionXliffFolder
			}
		}
	}
	
	XliffSelectionXliffFiles[]
	{
		set {
			if value {
				Menu, XliffSelection, Uncheck, % TrayMenu.MenuItem.XliffSelectionFileNameScheme
				Menu, XliffSelection, Uncheck, % TrayMenu.MenuItem.XliffSelectionXliffFolder
				Menu, XliffSelection, Check, % TrayMenu.MenuItem.XliffSelectionXliffFiles
			} else {
				Menu, XliffSelection, Uncheck, % TrayMenu.MenuItem.XliffSelectionXliffFiles
				Menu, XliffSelection, Disable, % TrayMenu.MenuItem.XliffSelectionXliffFiles
			}
		}
	}
	
	EnableLoadStandardIni()
	{
		Menu, Tray, Enable, % this.MenuItem.LoadStandardIni
	}
	
	EnableLoadIni()
	{
		Menu, Tray, Enable, % this.MenuItem.LoadIni
	}
}

class TrayMenuEvent {
	XliffLinked()
	{
		if Config.XliffLinked {
			MsgBox, 8193, % Txt.Get("RemoveXliffLinkMsgBoxTitle")
				, % Txt.Get("RemoveXliffLinkMsgBoxText")
			IfMsgBox, OK
			{
				Config.XliffLinked := 0
				TrayMenu.XliffLinked := 0
			}
		} else {
			LinkXliffDialog.Box(XGui.ActiveTab)
		}
	}
	XliffSelectionFileNameScheme()
	{
		if (Config.XliffSelectionMode != "FileNameScheme") {
			MsgBox, 8193, % Txt.Get("XliffSelectionFileNameSchemeMsgBoxTitle")
				, % Txt.Get("XliffSelectionFileNameSchemeMsgBoxText")
			IfMsgBox Cancel
				return
			XGui.XtReset(1)
			XGui.X2vReset(1)
			Adapter.ResetXliffInput()
			Config.XliffSelectionMode := "FileNameScheme"
			TrayMenu.XliffSelectionFileNameScheme := 1
		}
	}
	XliffSelectionXliffFolder()
	{
		if (Config.XliffSelectionMode != "Folder") {
			MsgBox, 8193, % Txt.Get("XliffSelectionXliffFolderMsgBoxTitle")
				, %  Txt.Get("XliffSelectionXliffFolderMsgBoxText")
			IfMsgBox Cancel
				return
			XGui.XtReset(1)
			XGui.X2vReset(1)
			Input.ResetXliff()
			Config.XliffSelectionMode := "Folder"
			TrayMenu.XliffSelectionXliffFolder := 1
		}
	}
	XliffSelectionXliffFiles()
	{
		if (Config.XliffSelectionMode != "Files") {
			MsgBox, 8193, % Txt.Get("XliffSelectionXliffFilesMsgBoxTitle")
				, % Txt.Get("XliffSelectionXliffFilesMsgBoxText")
			IfMsgBox Cancel
				return
			XGui.XtReset(1)
			XGui.X2vReset(1)
			Input.ResetXliff()
			Config.XliffSelectionMode := "Files"
			TrayMenu.XliffSelectionXliffFiles := 1
		}
	}
	LoadIni()
	{
		LoadIniDialog.Box()
	}
	SaveIni()
	{
		SaveIniDialog.Box()
	}
	LoadStandardIni()
	{
		MsgBox, 8193, % Txt.Get("LoadDefaultSettingsMsgBoxTitle")
			, % Txt.Get("LoadDefaultSettingsMsgBoxText")
		IfMsgBox Cancel
			return
		if Config.LoadIni() {
			MsgBox, 8256, % Txt.Get("LoadDefaultSettingsDoneMsgBoxTitle")
				, % Txt.Get("LoadDefaultSettingsDoneMsgBoxText")
		}
	}
	SaveStandardIni()
	{
		MsgBox, 8193, % Txt.Get("SaveDefaultSettingsMsgBoxTitle")
			, % Txt.Get("SaveDefaultSettingsMsgBoxText")
		IfMsgBox Cancel
			return
		if Config.SaveIni() {
			TrayMenu.EnableLoadStandardIni()
			MsgBox, 8256, % Txt.Get("SaveDefaultSettingsDoneMsgBoxTitle")
				, % Txt.Get("SaveDefaultSettingsDoneMsgBoxText")
		}
	}
	ResetConfig()
	{
		MsgBox, 8193, % Txt.Get("ResetMsgBoxTitle")
			, % Txt.Get("ResetMsgBoxText")
		IfMsgBox Cancel
			return
		TrayMenu.XliffLinked := 0
		TrayMenu.XliffSelectionFileNameScheme := 1
		XGui.XtReset(1)
		XGui.X2vReset(1)
		XGui.V2xReset(1)
		Config.Reset()
		Input.Reset()
		MsgBox, 8256, % Txt.Get("ResetDoneMsgBoxTitle")
			, % Txt.Get("ResetDoneMsgBoxText")
	}
	Exit()
	{
		ExitApp
	}
}