class Txt {
	static XliffUnitTextXslt := ComObjCreate("MSXML2.FreeThreadedDOMDocument.6.0")
		, XlifferXliffDoc := ComObjCreate("MSXML2.DOMDocument.6.0")
		, LanguageCode := "en"
	
	Init()
	{
		if !IsObject(this.XliffUnitTextXslt){
			MsgBox, 8208, Dependency Error,
			( LTrim
				This application is dependent on MSXML 6.0.
				Please install MSXML 6.0 and restart the application.
			)
			ExitApp
		}
		
		this.XliffUnitTextXslt.async := false
		this.XliffUnitTextXslt.setProperty("SelectionNamespaces", "xmlns:xsl='http://www.w3.org/1999/XSL/Transform' xmlns:xf='xl:ffer'")
		this.XliffUnitTextXslt.load(A_ScriptDir "\resources\xliff-unit-text.xsl")
		
		this.XlifferXliffDoc.async := false
		this.XlifferXliffDoc.validateOnParse := false
		this.XlifferXliffDoc.setProperty("SelectionNamespaces", "xmlns:xlf='urn:oasis:names:tc:xliff:document:1.2'")
		Loop, Files, % A_ScriptDir "\language\*xliffer.*"
		{
			if (A_LoopFileExt = "xlf" or A_LoopFileExt = "xliff") {
				this.XlifferXliffDoc.load(A_LoopFileLongPath)
				FileNodes := this.XlifferXliffDoc.selectNodes("/xlf:xliff/xlf:file[@original='xliffer.ahk']")
				for item in FileNodes
				{
					SourceLang := ""
					, TargetLang := ""
					SourceLangNode := item.selectSingleNode("@source-language")
					if IsObject(SourceLangNode) {
						SourceLang := SourceLangNode.Text
					}
					TargetLangNode := item.selectSingleNode("@target-language")
					if IsObject(TargetLangNode) {
						TargetLang := TargetLangNode.Text
					}
					if (SourceLang = Config.Language and not TargetLang or TargetLang = Config.Language) {
						this.LanguageCode := Config.Language
						break 2
					}
				}
			}
		}
		if (this.LanguageCode != Config.Language) {
			this.XlifferXliffDoc.load(A_ScriptDir "\language\xliffer.xlf")
		}
	}
	
	Get(TransUnitId, Variables := "")
	{
		if IsObject(Variables) {
			XtVariableNodes := this.XliffUnitTextXslt.selectNodes("/xsl:stylesheet/xsl:param[@name='variables']/xf:variable")
			for node in XtVariableNodes {
				node.parentNode.removeChild(node)
			}
			VariablesParamNode := this.XliffUnitTextXslt.selectSingleNode("/xsl:stylesheet/xsl:param[@name='variables']")
			for key, value in Variables {
				newVariable := this.XliffUnitTextXslt.createNode(1, "variable", "xl:ffer")
				newVariable.setAttribute("id", key)
				newVariable.Text := value
				VariablesParamNode.appendChild(newVariable)
			}
		}
		Xslt := ComObjCreate("MSXML2.XSLTemplate.6.0")
		Xslt.stylesheet := this.XliffUnitTextXslt
		XsltProc := Xslt.createProcessor()
		XsltProc.input := this.XlifferXliffDoc
		XsltProc.addParameter("languageCode", this.LanguageCode)
		XsltProc.addParameter("transUnitId", TransUnitId)
		XsltProc.transform()
		return XsltProc.output
	}
	
}