/**
 * Tab 3: XLIFF from Illustrator variable library
 *
 * Methods and Properties
 *
 * this file is included inside class definition
 *
class XGui
{
*/

	AddGuiElementsToTabV2x()
	{
		global V2xButton

		GroupBoxHeight := 81
		NextGroupBoxYs := GroupBoxHeight + this.GroupBoxGap

		Gui, Tab, 3
		Gui, Add, Text, % "x" this.FirstElementX " y" this.FirstElementY " w430 r1 Section"
			, % Txt.Get("V2xHeaderText")
		Gui, Add, GroupBox, % "xs-5 ys28 w" this.GroupBoxWidth " h" GroupBoxHeight " Section"
		this.AddGuiElementsToGroupBoxV2XFile()

		NextGroupBoxYs := GroupBoxHeight + this.GroupBoxGap
		GroupBoxHeight := 316
		Gui, Add, GroupBox, % "xs0 ys" NextGroupBoxYs " w" this.GroupBoxWidth " h" GroupBoxHeight " Section"
		this.AddGuiElementsToGroupBoxV2XSettings()

		Gui, Add, Button, % "xs-1 ys" GroupBoxHeight + 12 " w462 h30 vV2xButton gEvent.V2xButton Disabled"
			, % Txt.Get("V2xButton")
	}
	
	;* Input file

	AddGuiElementsToGroupBoxV2xFile()
	{
		global V2xFileEdit
			, V2xFileButton

		Gui, Add, Text, % "xs" this.GroupBoxLabelXs " ys0 r1"
			, % " " Txt.Get("V2xFileGroupBoxLabel") " "
		Gui, Add, Text, % "xs" this.Xs1 " ys" this.Ys1 " r1"
			, % Txt.Get("V2xFileText")
		Gui, Add, Edit, xp0 yp20 w403 h20 ReadOnly vV2xFileEdit
		Gui, Add, Button, xp406 yp-1 w30 h22 vV2XFileButton hwndOpenButton gEvent.V2xFileButton
		GuiButtonIcon(OpenButton, "resources\folder-open.ico")
	}
	
	V2xFileEdit[]
	{
		set {
			global X2vFolderEdit
			GuiControl,, V2xFileEdit, % value
		}
	}
	
	;* Extraction settings

	AddGuiElementsToGroupBoxV2XSettings()
	{
		global V2xSettingsLabel
			, V2xSettingsText
			, V2xSourceLangText
			, V2xSourceLangEdit
			, V2xFromDataSetText
			, V2xSourceLangDataSetDropDown
			, V2xTargetLangText
			, V2xAllTargetLangRadio
			, V2xChooseTargetLangRadio
			, V2xListView
			, ListViewHeader

		Gui, Add, Text, % "xs" this.GroupBoxLabelXs " ys0 r1 vV2xSettingsLabel Disabled"
			, % " " Txt.Get("V2XSettingsGroupBoxLabel") " "
		Gui, Add, Text, % "xs" this.Xs1 " ys31 r1 vV2xSettingsText Disabled"
			, % Txt.Get("V2xSettingsText")
		Gui, Add, Text, % "xp0 yp24 r1 vV2xSourceLangText Disabled"
			, % Txt.Get("V2xSourceLangText")
		GuiControlGet, ControlPos, Pos, V2xSourceLangText
		Gui, Add, Edit, % "xp" ControlPosW + 5 " yp-3 w55 h19 vV2xSourceLangEdit HwndH gEvent.V2xSourceLangEdit Disabled"
		this.HWND.V2xSourceLangEdit := H
		Gui, Add, Text, % "xp60 yp3 r1 vV2xFromDataSetText Disabled"
			, % Txt.Get("V2xFromDataSetText")
		ControlsWidth := ControlPosW + 65
		GuiControlGet, ControlPos, Pos, V2xFromDataSetText
		ControlsWidth += ControlPosW
		Gui, Add, DropDownList
			, % "xp" ControlPosW + 7 " yp-3 w" 428 - ControlsWidth " vV2xSourceLangDataSetDropDown gEvent.V2xSourceLangDataSetDropDown Disabled"
		Gui, Add, Text, % "xs13 yp39 r1 vV2xTargetLangText Disabled"
			, % Txt.Get("V2xTargetLangText")
		Gui, Add, Radio, % "xs13 yp23 r1 vV2xAllTargetLangRadio HwndH gEvent.V2xAllTargetLangRadio Disabled Checked"
			, % Txt.Get("V2xAllTargetLangRadio")
		this.HWND.V2xAllTargetLangRadio := H
		Gui, Add, Radio, % "xp0 yp21 r1 vV2xChooseTargetLangRadio HwndH gEvent.V2xChooseTargetLangRadio Disabled"
			, % Txt.Get("V2xChooseTargetLangRadio")
		this.HWND.V2xChooseTargetLangRadio := H
		Gui, Add, ListView
			, xp16 yp20 w418 -Readonly -Checked Disabled c808080 NoSortHdr -Multi 0x2000 LV0x10000 -LV0x10 -LV0x20 -E0x200 r7 HwndV2xLV vV2xListView gV2xListViewEvent
			,  % Txt.Get("V2xListViewTargetLanguageCol") "|" Txt.Get("V2xListViewFromDataSetCol")
		Gui, +LastFound
		SendMessage, LVM_GETHEADER := 0x101F, 0, 0, , ahk_id %V2xLV%
		HHEADER := ErrorLevel
		ListViewHeader.V2xLV := HHEADER
		ListViewHeader[HHEADER] := 0
		SendMessage, LVM_GETCOLUMNWIDTH := 0x101D, 1, 0, ahk_id %V2xLV%
		Col2Width := ErrorLevel
		this.ListViewCol2Width.V2x.Regular := Col2Width
		this.ListViewCol2Width.V2x.MinusScrollBar := Col2Width - this.VerticalScrollBarWidth
	}
	
	V2xSettings[Mode := "Enable"]
	{
		set {
			this.SetGuiControlMode(Mode, value)
			this.V2xSettingsLabel[Mode] := 1
			this.V2xSettingsText[Mode] := 1
			this.V2xSourceLangText[Mode] := 1
			this.V2xSourceLangEdit[Mode] := 1
			this.V2xFromDataSetText[Mode] := 1
			this.V2xSourceLangDataSetDropDown[Mode] := 1
			this.V2xTargetLangText[Mode] := 1
			this.V2xAllTargetLangRadio[Mode] := 1
			this.V2xChooseTargetLangRadio[Mode] := 1
			if Mode in Enable0,Disable1
			{
				this.V2xListView[Mode] := 1
			}
		}
	}
	
	V2xSettingsLabel[Mode := "Enable"]
	{
		set {
			global V2xSettingsLabel
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, V2xSettingsLabel
			}
		}
	}
	
	V2xSettingsText[Mode := "Enable"]
	{
		set {
			global V2xSettingsText
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, V2xSettingsText
			}
		}
	}
	
	V2xSourceLangText[Mode := "Enable"]
	{
		set {
			global V2xSourceLangText
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, V2xSourceLangText
			}
		}
	}
	
	V2xSourceLangEdit[Mode := "Text"]
	{
		get {
			global V2xSourceLangEdit
			GuiControlGet, EditText,, V2xSourceLangEdit
			return EditText
		}
		set {
			global V2xSourceLangEdit
			if (Mode = "Text") {
				GuiControl,, V2xSourceLangEdit, % value
			} else if (Mode = "Focus") {
				GuiControl, Focus, V2xSourceLangEdit
				if value {
					SendInput, ^a
				}
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, V2xSourceLangEdit
				}
			}
		}
	}
	
	V2xFromDataSetText[Mode := "Enable"]
	{
		set {
			global V2xFromDataSetText
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, V2xFromDataSetText
			}
		}
	}
	
	V2xSourceLangDataSetDropDown[Mode := "Keys"]
	{
		get {
			global V2xSourceLangDataSetDropDown
			GuiControlGet, Selection,, V2xSourceLangDataSetDropDown
			return Selection
		}
		set {
			global V2xSourceLangDataSetDropDown
			if (Mode = "Keys") {
				if value {
					for key in value {
						List .= "|" key
					}
				} else {
					List := "|"
				}
				GuiControl,, V2xSourceLangDataSetDropDown, % List
			} else if (Mode = "Choose") {
				Selection := (value) ? value : 0
				GuiControl, Choose, V2xSourceLangDataSetDropDown, % Selection
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, V2xSourceLangDataSetDropDown
				}
			}
		}
	}
	
	V2xTargetLangText[Mode := "Enable"]
	{
		set {
			global V2xTargetLangText
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, V2xTargetLangText
			}
		}
	}
	
	V2xAllTargetLangRadio[Mode := "Check"]
	{
		get {
			global V2xAllTargetLangRadio
			GuiControlGet, EnabledState, Enabled, V2xAllTargetLangRadio
			return EnabledState
		}
		set {
			global V2xAllTargetLangRadio
			if (Mode = "Check") {
				Control, Check,,, % "ahk_id " this.HWND.V2xAllTargetLangRadio
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, V2xAllTargetLangRadio
				}
			}
		}
	}
	
	V2xChooseTargetLangRadio[Mode := "Check"]
	{
		get {
			global V2xChooseTargetLangRadio
			GuiControlGet, CheckState,, V2xChooseTargetLangRadio
			return CheckState
		}
		set {
			global V2xChooseTargetLangRadio
			if (Mode = "Check") {
				Control, Check,,, % "ahk_id " this.HWND.V2xChooseTargetLangRadio
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, V2xChooseTargetLangRadio
				}
			}
		}
	}
	
	V2xListView[Mode := "Object", Exclude := 0]
	{
		get {
			global V2xListView
			if (A_DefaultListView != "V2xListView") {
				Gui, ListView, V2xListView
			}
			if Mode is integer
			{
				LV_GetText(Field1, Mode)
				LV_GetText(Field2, Mode, 2)
				return [Field1, Field2]
			} else if (Mode = "Keys") {
				List := {}
				Loop % LV_GetCount()
				{
					if (A_Index != Exclude) {
						LV_GetText(Field1, A_Index)
						List[Field1] := A_Index
					}
				}
				return List
			} else if (Mode = "Selection") {
				List := {}
				RowNumber = 0
				Loop
				{
					RowNumber := LV_GetNext(RowNumber, "Checked")
					if not RowNumber {
						break
					}
					LV_GetText(Field1, RowNumber)
					LV_GetText(Field2, RowNumber, 2)
					List[Field2] := {}
					if (Field1 != Field2) {
						List[Field2].DataSetName := Field1
					}
				}
				return List
			} else {
				List := {}
				NextChecked := LV_GetNext(0, "Checked")
				Loop % LV_GetCount()
				{
					LV_GetText(Field1, A_Index)
					LV_GetText(Field2, A_Index, 2)
					List[Field2] := {}
					if (Field1 != Field2) {
						List[Field2].TargetLanguage := Field1
					}
					if (A_Index = NextChecked) {
						List[Field2].Check := 1
						NextChecked := LV_GetNext(A_Index, "Checked")
					}
				}
				return List
			}
		}
		set {
			global V2xListView
			, ListViewHeader
			if Mode is integer
			{
				if (A_DefaultListView != "V2xListView")	{
					Gui, ListView, V2xListView
				}
				LV_Modify(Mode,, value)
			} else if (Mode = "Object") {
				if (A_DefaultListView != "V2xListView")	{
					Gui, ListView, V2xListView
				}
				LV_Delete()
				if Exclude {
					value.Delete(Exclude)
				}
				for DataSetName, item in value {
					Options := (item.Check) ? "Check" : ""
					Field1 := (item.TargetLanguage) ? item.TargetLanguage : DataSetName
					Field2 := DataSetName
					LV_Add(Options, Field1, Field2)
				}
				Col2Width := (LV_GetCount() > 7)
					? this.ListViewCol2Width.V2x.MinusScrollBar
					: this.ListViewCol2Width.V2x.Regular
				LV_ModifyCol(2, Col2Width)
			} else if (Mode = "Checkable") {
				GuiControl, +Checked, V2xListView
			} else if (Mode = "CheckAll") {
				Loop % LV_GetCount()
				{
					LV_Modify(A_Index, "+Check")
				}
			} else {
				this.SetGuiControlMode(Mode, value)
				if Mode in Enable1,Disable0
				{
					GuiControl, +Checked -Disabled -Color -0x2000, V2xListView
					ListViewHeader[ListViewHeader.V2xLV] := 1
				} else if Mode in Enable0,Disable1
				{
					GuiControl, +Disabled +c808080, V2xListView
					ListViewHeader[ListViewHeader.V2xLV] := 0
					if (A_DefaultListView != "V2xListView")	{
						Gui, ListView, V2xListView
					}
					RowNumber = 0
					Loop
					{
						RowNumber := LV_GetNext(RowNumber, "Focused")
						if not RowNumber {
							break
						}
						LV_Modify(RowNumber, "-Focus -Select")
					}
				}
			}
		}
	}
	
	V2xButton[Mode := "Enable"]
	{
		set {
			global V2xButton
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, V2xButton
			}
		}
	}
	
	V2xReset(All := 0)
	{
		if (All) {
			this.V2xFileEdit := ""
		}
		this.V2xSourceLangEdit := ""
		this.V2xSourceLangDataSetDropDown := ""
		this.V2xAllTargetLangRadio["Enable"] := 1
		this.V2xAllTargetLangRadio := 1
		this.V2xListView := ""
		this.V2xSettings := 0
		this.V2xButton := 0
	}

/*
 * mind: this file is included inside class definition,
 * so don't write double close bracket
 *
}
*/