/**
 * Tab 2: XLIFF to Illustrator variable library
 *
 * Methods and Properties
 *
 * this file is included inside class definition
 *
class XGui
{
*/

	AddGuiElementsToTabX2v()
	{
		global X2vButton

		GroupBoxHeight := 81
		NextGroupBoxYs := GroupBoxHeight + this.GroupBoxGap

		Gui, Tab, 2
		Gui, Add, Text, % "x" this.FirstElementX " y" this.FirstElementY " w430 r1 Section"
			, % Txt.Get("X2vHeaderText")
		Gui, Add, GroupBox, % "xs-5 ys28 w" this.GroupBoxWidth " h" GroupBoxHeight " Section"
		this.AddGuiElementsToGroupBoxX2VFolder()

		GroupBoxHeight := 58
		Gui, Add, GroupBox, % "xs0 ys" NextGroupBoxYs " w" this.GroupBoxWidth " h" GroupBoxHeight " Section"
		this.AddGuiElementsToGroupBoxX2VXliff()

		NextGroupBoxYs := GroupBoxHeight + this.GroupBoxGap
		GroupBoxHeight := 248
		Gui, Add, GroupBox, % "xs0 ys" NextGroupBoxYs " w" this.GroupBoxWidth " h" GroupBoxHeight " Section"
		this.AddGuiElementsToGroupBoxX2VSettings()

		Gui, Add, Button, % "xs-1 ys" GroupBoxHeight + 12 " w462 h30 vX2vButton gEvent.X2vButton Disabled"
			, % Txt.Get("X2vButton")
	}
	
	;* Input folder

	AddGuiElementsToGroupBoxX2vFolder()
	{
		global X2vFolderEdit
			, X2vFolderButton

		Gui, Add, Text, % "xs" this.GroupBoxLabelXs " ys0 r1"
			, % " " Txt.Get("X2vFolderGroupBoxLabel") " "
		Gui, Add, Text, % "xs" this.Xs1 " ys" this.Ys1 " w434 r1"
			, % Txt.Get("X2vFolderText")
		Gui, Add, Edit, xp0 yp20 w403 h20 ReadOnly vX2vFolderEdit
		Gui, Add, Button, xp406 yp-1 w30 h22 vX2vFolderButton hwndOpenButton gEvent.FolderButton
		GuiButtonIcon(OpenButton, "resources\folder-open.ico")
	}
	
	X2vFolderEdit[]
	{
		get {
			global X2vFolderEdit
			GuiControlGet, EditText,, X2vFolderEdit
			return EditText
		}
		set {
			global X2vFolderEdit
			GuiControl,, X2vFolderEdit, % value
		}
	}
	
	;* XLIFF file set / selection

	AddGuiElementsToGroupBoxX2VXliff()
	{
		global X2vXliffLabel
			, X2vXliffText
			, X2vXliffDropDown

		Gui, Add, Text, % "xs" this.GroupBoxLabelXs " ys0 r1 vX2vXliffLabel Disabled"
			, % " " Txt.Get("DefaultXliffGroupBoxLabel") " "
		Gui, Add, Text, % "xs" this.Xs1 " ys" this.Ys1 " w235 r1 vX2vXliffText Disabled"
			, % Txt.Get("DefaultXliffText")
		Gui, Add, DropDownList, % "xp219 yp-3 w216 vX2vXliffDropDown gEvent.X2vXliffDropDown Disabled"
	}
	
	X2vXliff[Mode := "Enable"]
	{
		set {
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				this.X2vXliffLabel[Mode] := 1
				this.X2vXliffText[Mode] := 1
				this.X2vXliffDropDown[Mode] := 1
			}
		}
	}
	
	X2vXliffLabel[Mode := "Text"]
	{
		set {
			global X2vXliffLabel
			if (Mode = "Text") {
				LabelText := (value) ? value : Txt.Get("DefaultXliffGroupBoxLabel")
				GuiControl,, X2vXliffLabel, % " " LabelText " "
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, X2vXliffLabel
				}
			}
		}
	}
	
	X2vXliffText[Mode := "Text"]
	{
		set {
			global X2vXliffText
				, X2vXliffDropDown
			if (Mode = "Text") {
				NewText := (value) ? value : Txt.Get("DefaultXliffText")
				NewTextWidth := this.GetNewTextWidth(NewText)
				GuiControlGet, TextPos, Pos, X2vXliffText
				GuiControl,, X2vXliffText, % NewText
				GuiControl, MoveDraw, X2vXliffText, % "w" NewTextWidth
				GuiControl, MoveDraw, X2vXliffDropDown
					, % "x" TextPosX + NewTextWidth - this.TabX + 5 " w" 428 - NewTextWidth
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, X2vXliffText
				}
			}
		}
	}
	
	X2vXliffDropDown[Mode := "List"]
	{
		get {
			global X2vXliffDropDown
			GuiControlGet, Selection,, X2vXliffDropDown
			return Selection
		}
		set {
			global X2vXliffDropDown
			if (Mode = "List" or Mode = "Raw") {
				if IsObject(value) {
					for key, val in value {
						List .= "|" val
					}
				} else if (Mode = "Raw") {
					List := value
				} else if (not SubStr(value, 1, 1) = "|") {
					List := "|" value
				}
				GuiControl,, X2vXliffDropDown, % List
			} else if (Mode = "Choose") {
				Selection := (value) ? value : 0
				GuiControl, Choose, X2vXliffDropDown, % Selection
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, X2vXliffDropDown
				}
			}
		}
	}
	
	;* Transformation settings

	AddGuiElementsToGroupBoxX2vSettings()
	{
		global X2vSettingsLabel
			, X2vSourceLangDataSetText
			, X2vSourceLangDataSetEdit
			, X2vFromSourceLangText
			, X2vAllTargetLangRadio
			, X2vChooseTargetLangRadio
			, X2vListView
			, ListViewHeader

		Gui, Add, Text, % "xs" this.GroupBoxLabelXs " ys0 r1 vX2vSettingsLabel Disabled"
			, % " " Txt.Get("X2vSettingsGroupBoxLabel") " "
		Gui, Add, Text, % "xs" this.Xs1 " ys23 r1 vX2vSourceLangDataSetText Disabled"
			, % Txt.Get("X2vSourceLangDataSetText")
		GuiControlGet, ControlPos, Pos, X2vSourceLangDataSetText
		Gui, Add, Edit, % "xp" ControlPosW + 5 " yp-3 w55 h19 vX2vSourceLangDataSetEdit HwndH gEvent.X2vSourceLangDataSetEdit Disabled"
		this.HWND.X2vSourceLangDataSetEdit := H
		OnMessage(0x111, "On_ControlLostFocus")
		Gui, Add, Text, % "xp60 yp3 r1 w" 370 - ControlPosW " vX2vFromSourceLangText Disabled"
			, % Txt.Get("DefaultX2vFromSourceLangText")
		Gui, Add, Radio, % "xs" this.Xs1 " yp23 r1 vX2vAllTargetLangRadio HwndH gEvent.X2vAllTargetLangRadio Checked Disabled"
			, % Txt.Get("X2vAllTargetLangRadio")
		this.HWND.X2vAllTargetLangRadio := H
		Gui, Add, Radio, % "xp0 yp21 r1 vX2vChooseTargetLangRadio HwndH gEvent.X2vChooseTargetLangRadio Disabled"
			, % Txt.Get("X2vChooseTargetLangRadio")
		this.HWND.X2vChooseTargetLangRadio := H
		Gui, Add, ListView
			, xp16 yp20 w418 -Readonly -Checked Disabled c808080 NoSortHdr -Multi 0x2000 LV0x10000 -LV0x10 -LV0x20 -E0x200 r7 HwndX2vLV vX2vListView gX2vListViewEvent
			, % Txt.Get("X2vListViewDataSetCol") "|" Txt.Get("X2vListViewFromTargetLangCol")
		Gui, +LastFound
		SendMessage, LVM_GETHEADER := 0x101F, 0, 0, , ahk_id %X2vLV%
		HHEADER := ErrorLevel
		ListViewHeader.X2vLV := HHEADER
		ListViewHeader[HHEADER] := 0
		OnMessage(WM_NOTIFY := 0x004E, "On_ListViewHeaderOnOff")
		SendMessage, LVM_GETCOLUMNWIDTH := 0x101D, 1, 0, ahk_id %X2vLV% 
		Col2Width := ErrorLevel
		this.ListViewCol2Width.X2v.Regular := Col2Width
		this.ListViewCol2Width.X2v.MinusScrollBar := Col2Width - this.VerticalScrollBarWidth
	}
	
	X2vSettings[Mode := "Enable"]
	{
		set {
			this.SetGuiControlMode(Mode, value)
			this.X2vSettingsLabel[Mode] := 1
			this.X2vSourceLangDataSetText[Mode] := 1
			this.X2vSourceLangDataSetEdit[Mode] := 1
			this.X2vFromSourceLangText[Mode] := 1
			this.X2vAllTargetLangRadio[Mode] := 1
			this.X2vChooseTargetLangRadio[Mode] := 1
			if Mode in Enable0,Disable1
			{
				this.X2vListView[Mode] := 1
			}
		}
	}
	
	X2vSettingsLabel[Mode := "Enable"]
	{
		set {
			global X2vSettingsLabel
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, X2vSettingsLabel
			}
		}
	}
	
	X2vSourceLangDataSetText[Mode := "Enable"]
	{
		set {
			global X2vSourceLangDataSetText
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, X2vSourceLangDataSetText
			}
		}
	}
	
	X2vSourceLangDataSetEdit[Mode := "Text"]
	{
		get {
			global X2vSourceLangDataSetEdit
			GuiControlGet, EditText,, X2vSourceLangDataSetEdit
			return EditText
		}
		set {
			global X2vSourceLangDataSetEdit
			if (Mode = "Text") {
				GuiControl,, X2vSourceLangDataSetEdit, % value
			} else if (Mode = "Focus") {
				GuiControl, Focus, X2vSourceLangDataSetEdit
				if value {
					SendInput, ^a
				}
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, X2vSourceLangDataSetEdit
				}
			}
		}
	}
	
	X2vFromSourceLangText[Mode := "LangCode"]
	{
		set {
			global X2vFromSourceLangText
			if (Mode = "LangCode") {
				if (value) {
					NewText := Txt.Get("X2vFromSourceLangText", {SourceLang: value})
				} else {
					NewText := Txt.Get("DefaultX2vFromSourceLangText")
				}
				GuiControl,, X2vFromSourceLangText, % NewText
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, X2vFromSourceLangText
				}
			}
		}
	}
	
	X2vAllTargetLangRadio[Mode := "Check"]
	{
		set {
			global X2vAllTargetLangRadio
			if (Mode = "Check") {
				Control, Check,,, % "ahk_id " this.HWND.X2vAllTargetLangRadio
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, X2vAllTargetLangRadio
				}
			}
		}
	}
	
	X2vChooseTargetLangRadio[Mode := "Check"]
	{
		get {
			global X2vChooseTargetLangRadio
			GuiControlGet, CheckState,, X2vChooseTargetLangRadio
			return CheckState
		}
		set {
			global X2vChooseTargetLangRadio
			if (Mode = "Check") {
				Control, Check,,, % "ahk_id " this.HWND.X2vChooseTargetLangRadio
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, X2vChooseTargetLangRadio
				}
			}
		}
	}
	
	X2vListView[Mode := "Object", Exclude := 0]
	{
		get {
			global X2vListView
			if (A_DefaultListView != "X2vListView") {
				Gui, ListView, X2vListView
			}
			if Mode is integer
			{
				LV_GetText(Field1, Mode)
				LV_GetText(Field2, Mode, 2)
				return [Field1, Field2]
			} else if (Mode = "Keys") {
				List := {}
				Loop % LV_GetCount()
				{
					if (A_Index != Exclude) {
						LV_GetText(Field1, A_Index)
						List[Field1] := A_Index
					}
				}
				return List
			} else if (Mode = "Selection") {
				List := []
				RowNumber = 0
				Loop
				{
					RowNumber := LV_GetNext(RowNumber, "Checked")
					if not RowNumber {
						break
					}
					Item := {}
					LV_GetText(Field1, RowNumber)
					LV_GetText(Field2, RowNumber, 2)
					if (Field1 != Field2) {
						Item.DataSetName := Field1
					}
					Item.TargetLanguage := Field2
					List.Push(Item)
				}
				return List
			} else {
				List := {}
				NextChecked := LV_GetNext(0, "Checked")
				Loop % LV_GetCount()
				{
					LV_GetText(Field1, A_Index)
					LV_GetText(Field2, A_Index, 2)
					List[Field2] := {}
					if (Field1 != Field2) {
						List[Field2].DataSetName := Field1
					}
					if (A_Index = NextChecked) {
						List[Field2].Check := 1
						NextChecked := LV_GetNext(A_Index, "Checked")
					}
				}
				return List
			}
		}
		set {
			global X2vListView
				, ListViewHeader
			if Mode is integer
			{
				if (A_DefaultListView != "X2vListView")	{
					Gui, ListView, X2vListView
				}
				LV_Modify(Mode,, value)
			} else if (Mode = "Object") {
				if (A_DefaultListView != "X2vListView")	{
					Gui, ListView, X2vListView
				}
				LV_Delete()
				for TargetLang, item in value {
					Options := (item.Check) ? "Check" : ""
					Field1 := (item.DataSetName) ? item.DataSetName : TargetLang
					Field2 := TargetLang
					LV_Add(Options, Field1, Field2)
				}
				Col2Width := (LV_GetCount() > 7)
					? this.ListViewCol2Width.X2v.MinusScrollBar
					: this.ListViewCol2Width.X2v.Regular
				LV_ModifyCol(2, Col2Width)
			} else if (Mode = "Checkable") {
				GuiControl, +Checked, X2vListView
			} else {
				this.SetGuiControlMode(Mode, value)
				if Mode in Enable1,Disable0
				{
					GuiControl, +Checked -Disabled -Color -0x2000, X2vListView
					ListViewHeader[ListViewHeader.X2vLV] := 1
				} else if Mode in Enable0,Disable1
				{
					GuiControl, +Disabled +c808080, X2vListView
					ListViewHeader[ListViewHeader.X2vLV] := 0
					if (A_DefaultListView != "X2vListView")	{
						Gui, ListView, X2vListView
					}
					RowNumber = 0
					Loop
					{
						RowNumber := LV_GetNext(RowNumber, "Focused")
						if not RowNumber {
							break
						}
						LV_Modify(RowNumber, "-Focus -Select")
					}
				}
			}
		}
	}
	
	X2vButton[Mode := "Enable"]
	{
		set {
			global X2vButton
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, X2vButton
			}
		}
	}
	
	X2vReset(All := 0)
	{
		if (All) {
			this.X2vFolderEdit := ""
			this.X2vXliffDropDown := ""
			this.X2vXliff := 0
		}
		this.X2vSourceLangDataSetEdit := " "
		this.X2vFromSourceLangText := ""
		this.X2vAllTargetLangRadio := 1
		this.X2vListView := ""
		this.X2vSettings := 0
		this.X2vButton := 0
	}

/*
 * mind: this file is included inside class definition,
 * so don't write double close bracket
 *
}
*/