/**
 * Tab 1: XLIFF Tools
 *
 * Methods and Properties
 *
 * this file is included inside class definition
 *
class XGui
{
*/

	AddGuiElementsToTabXt()
	{
		GroupBoxHeight := 81
		NextGroupBoxYs := GroupBoxHeight + this.GroupBoxGap

		Gui, Tab, 1
		Gui, Add, GroupBox, % "x" this.FirstElementX[11] " y" this.FirstElementY " w" this.GroupBoxWidth " h" GroupBoxHeight " Section"
		this.AddGuiElementsToGroupBoxXtFolder()
		
		GroupBoxHeight := 58
		Gui, Add, GroupBox, % "xs0 ys+" NextGroupBoxYs  " w" . this.GroupBoxWidth " h" GroupBoxHeight " Section"
		this.AddGuiElementsToGroupBoxXtXliff()
		
		NextGroupBoxYs := GroupBoxHeight + this.GroupBoxGap
		GroupBoxHeight := 89
		Gui, Add, GroupBox, % "xs0 ys+" NextGroupBoxYs  " w" this.GroupBoxWidth " h" GroupBoxHeight " Section"
		this.AddGuiElementsToGroupBoxXtConsistency()
		
		NextGroupBoxYs := GroupBoxHeight + this.GroupBoxGap
		GroupBoxHeight := 60
		Gui, Add, GroupBox, % "xs0 ys+" NextGroupBoxYs  " w" this.GroupBoxWidth " h" GroupBoxHeight " Section"
		this.AddGuiElementsToGroupBoxXtSource()
		
		NextGroupBoxYs := GroupBoxHeight + this.GroupBoxGap
		GroupBoxHeight := 58
		Gui, Add, GroupBox, % "xs0 ys+" NextGroupBoxYs  " w" this.GroupBoxWidth " h" GroupBoxHeight " Section"
		this.AddGuiElementsToGroupBoxXtTargetLang()
		
		NextGroupBoxYs := GroupBoxHeight + this.GroupBoxGap
		GroupBoxHeight := 85
		Gui, Add, GroupBox, % "xs0 ys+" NextGroupBoxYs  " w" this.GroupBoxWidth " h" GroupBoxHeight " Section"
		this.AddGuiElementsToGroupBoxXtSplitMerge()
	}
	
	;* Input folder

	AddGuiElementsToGroupBoxXtFolder()
	{
		global XtFolderEdit
			, XtFolderButton

		Gui, Add, Text, % "xs" this.GroupBoxLabelXs " ys0 r1"
			, % " " Txt.Get("XtFolderGroupBoxLabel") " "
		Gui, Add, Text, % "xs" this.Xs1 " ys" this.Ys1 " r1"
			, % Txt.Get("XtFolderText")
		Gui, Add, Edit, xp0 yp20 w403 h20 ReadOnly vXtFolderEdit
		Gui, Add, Button, xp406 yp-1 w30 h22 vXtFolderButton hwndOpenButton gEvent.FolderButton
		GuiButtonIcon(OpenButton, "resources\folder-open.ico")
	}
	
	XtFolderEdit[]
	{
		get {
			global XtFolderEdit
			GuiControlGet, EditText,, XtFolderEdit
			return EditText
		}
		set {
			global XtFolderEdit
			GuiControl,, XtFolderEdit, % value
		}
	}
	
	;* XLIFF file set / selection

	AddGuiElementsToGroupBoxXtXliff()
	{
		global XtXliffLabel
			, XtXliffText
			, XtXliffDropDown

		Gui, Add, Text, % "xs" this.GroupBoxLabelXs " ys0 r1 vXtXliffLabel Disabled"
			, % " " Txt.Get("DefaultXliffGroupBoxLabel") " "
		Gui, Add, Text, % "xs" this.Xs1 " ys" this.Ys1 " r1 vXtXliffText Disabled"
			, % Txt.Get("DefaultXliffText")
		GuiControlGet, TextPos, Pos, XtXliffText
		Gui, Add, DropDownList, % "xp" TextPosW + 7 " yp-3 w" 428 - TextPosW " vXtXliffDropDown gEvent.XtXliffDropDown Disabled"
	}
	
	XtXliff[Mode := "Enable"]
	{
		set {
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				this.XtXliffLabel[Mode] := 1
				this.XtXliffText[Mode] := 1
				this.XtXliffDropDown[Mode] := 1
			}
		}
	}
	
	XtXliffLabel[Mode := "Text"]
	{
		set {
			global XtXliffLabel
			if (Mode = "Text") {
				LabelText := (value) ? value : Txt.Get("DefaultXliffGroupBoxLabel")
				GuiControl,, XtXliffLabel, % " " LabelText " "
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, XtXliffLabel
				}
			}
		}
	}
	
	XtXliffText[Mode := "Text"]
	{
		set {
			global XtXliffText
				, XtXliffDropDown
			if (Mode = "Text") {
				NewText := (value) ? value : Txt.Get("DefaultXliffText")
				NewTextWidth := this.GetNewTextWidth(NewText)
				GuiControlGet, TextPos, Pos, XtXliffText
				GuiControl,, XtXliffText, % NewText
				GuiControl, MoveDraw, XtXliffText, % "w" NewTextWidth
				GuiControl, MoveDraw, XtXliffDropDown
					, % "x" TextPosX + NewTextWidth - this.TabX + 5 " w" 428 - NewTextWidth
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, XtXliffText
				}
			}
		}
	}
	
	XtXliffDropDown[Mode := "List"]
	{
		get {
			global XtXliffDropDown
			GuiControlGet, Selection,, XtXliffDropDown
			return Selection
		}
		set {
			global XtXliffDropDown
			if (Mode = "List" or Mode = "Raw") {
				if IsObject(value) {
					for key, val in value {
						List .= "|" val
					}
				} else if (Mode = "Raw") {
					List := value
				} else if (not SubStr(value, 1, 1) = "|") {
					List := "|" value
				}
				GuiControl,, XtXliffDropDown, % List
			} else if (Mode = "Choose") {
				Selection := (value) ? value : 0
				GuiControl, Choose, XtXliffDropDown, % Selection
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, XtXliffDropDown
				}
			}
		}
	}
	
	;* Consistency check

	AddGuiElementsToGroupBoxXtConsistency()
	{
		global XtConsistencyLabel
			, XtConsistencyText
			, XtConsistencyButton

		Gui, Add, Text, % "xs" this.GroupBoxLabelXs " ys0 r1 vXtConsistencyLabel Disabled"
			, % " " Txt.Get("XtConsistencyGroupBoxLabel") " "
		Gui, Add, Text, % "xs" this.Xs1 " ys" this.Ys1 " w440 r1 vXtConsistencyText Disabled"
			, % Txt.Get("DefaultXtConsistencyText")
		Gui, Add, Button, % "xp-2 yp23 w438 h26 vXtConsistencyButton gEvent.XtConsistencyButton Disabled"
			, % Txt.Get("XtConsistencyButton")
	}
	
	XtConsistency[Mode := "Enable"]
	{
		set {
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				this.XtConsistencyLabel[Mode] := 1
				this.XtConsistencyText[Mode] := 1
				this.XtConsistencyButton[Mode] := 1
			}
		}
	}
	
	XtConsistencyLabel[Mode := "Enable"]
	{
		set {
			global XtConsistencyLabel
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, XtConsistencyLabel
			}
		}
	}
	
	XtConsistencyText[Mode := "Text"]
	{
		set {
			global XtConsistencyText			
			if (Mode = "Text") {
				if (value) {
					XliffConsiderResult := Input.XliffConsiderResult["Xt"]
					if not XliffConsiderResult or XliffConsiderResult = "E" {
						FontColor := "cD8000C"
					} else if (XliffConsiderResult = "W") {
						FontColor := "c9F6000"
					}
				}
				Gui, Font, % FontColor
				GuiControl, Font, XtConsistencyText	
				NewText := (value) ? value : Txt.Get("DefaultXtConsistencyText")
				GuiControl,, XtConsistencyText, % NewText
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, XtConsistencyText
				}
			}
		}
	}
	
	XtConsistencyButton[Mode := "Enable"]
	{
		set {
			global XtConsistencyButton
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, XtConsistencyButton
			}
		}
	}
	
	;* Source language
	
	AddGuiElementsToGroupBoxXtSource()
	{
		global XtSourceLabel
			, XtExtractSourceRadio
			, XtRefreshSourceRadio
			, XtExchangeSourceRadio
			, XtExtractSourceText
			, XtExtractSourceDropDown
			, XtExtractSourceButton
			, XtRefreshSourceText
			, XtRefreshSourceFromTargetCheckBox
			, XtRefreshSourceFromTargetDropDown
			, XtRefreshSourceButton
			, XtExchangeSourceText
			, XtExchangeSourceTargetDropDown
			, XtExchangeSourceButton

		Gui, Add, Text, % "xs" this.GroupBoxLabelXs " ys0 r1 vXtSourceLabel Disabled"
			, % " " Txt.Get("XtSourceGroupBoxLabel") " "
		GuiControlGet, ControlPos, Pos, XtSourceLabel
		Gui, Add, Radio, % "xp" ControlPosW " yp0 r1 vXtExtractSourceRadio HwndH gEvent.XtExtractSourceRadio Checked Disabled"
			, % Txt.Get("XtExtractSourceRadio")
		this.HWND.XtExtractSourceRadio := H
		GuiControlGet, ControlPos, Pos, XtExtractSourceRadio
		Gui, Add, Radio, % "xp" ControlPosW " yp0 rt vXtRefreshSourceRadio gEvent.XtRefreshSourceRadio Disabled"
			, % Txt.Get("XtRefreshSourceRadio")
		GuiControlGet, ControlPos, Pos, XtRefreshSourceRadio
		Gui, Add, Radio, % "xp" ControlPosW " yp0 rt vXtExchangeSourceRadio gEvent.XtExchangeSourceRadio Disabled"
			, % Txt.Get("XtExchangeSourceRadio")
		Gui, Add, Text, % "xs13 ys26 r1 vXtExtractSourceText Disabled"
			, % Txt.Get("XtExtractSourceText")
		GuiControlGet, ControlPos, Pos, XtExtractSourceText
		Gui, Add, DropDownList, % "xp" ControlPosW + 7 " yp-3 w65 vXtExtractSourceDropDown gEvent.XtExtractSourceDropDown Disabled"
		Gui, Add, Button, % "xp75 yp-2 w" 354 - ControlPosW " h25 vXtExtractSourceButton gEvent.XtExtractSourceButton Disabled"
			, % Txt.Get("XtExtractSourceButton")
		Gui, Add, Text, % "xs13 ys26 r1 vXtRefreshSourceText Hidden Disabled"
			, % Txt.Get("XtRefreshSourceText")
		GuiControlGet, ControlPos, Pos, XtRefreshSourceText
		ControlsWidth := ControlPosW
		Gui, Add, CheckBox, % "xp" ControlPosW + 7 "yp0 r1 c808080 vXtRefreshSourceFromTargetCheckBox HwndH gEvent.XtRefreshSourceFromTargetCheckBox Hidden Disabled"
			, % Txt.Get("XtRefreshSourceFromTargetCheckBox")
		this.HWND.XtRefreshSourceFromTargetCheckBox := H
		GuiControlGet, ControlPos, Pos, XtRefreshSourceFromTargetCheckBox
		ControlsWidth += ControlPosW
		Gui, Add, DropDownList, % "xp" ControlPosW " yp-3 w60 vXtRefreshSourceFromTargetDropDown Hidden Disabled"
		Gui, Add, Button, % "xp69 yp-2 w" 360 - ControlsWidth " h25 vXtRefreshSourceButton gEvent.XtRefreshSourceButton Hidden Disabled"
			, % Txt.Get("XtRefreshSourceButton")
		Gui, Add, Text, % "xs13 ys26 r1 vXtExchangeSourceText Hidden Disabled"
			, % Txt.Get("XtExchangeSourceText")
		GuiControlGet, ControlPos, Pos, XtExchangeSourceText
		Gui, Add, DropDownList, % "xp" ControlPosW + 7 " yp-3 w60 vXtExchangeSourceTargetDropDown gEvent.XtExchangeSourceTargetDropDown Hidden Disabled"
		Gui, Add, Button, % "xp69 yp-2 w" 360 - ControlPosW " h25 vXtExchangeSourceButton gEvent.XtExchangeSourceButton Hidden Disabled"
			, % Txt.Get("XtExchangeSourceButton")
	}
	
	XtSource[Mode := "Enable"]
	{
		set {
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				this.XtSourceLabel[Mode] := 1
				this.XtExtractSource[Mode] := 1
			}
			if Mode in Enable0,Disable1
			{
				this.XtRefreshSource[Mode] := 1
				this.XtExchangeSource[Mode] := 1
			}
		}
	}
	
	XtExtractSource[Mode := "Enable"]
	{
		set {
			this.SetGuiControlMode(Mode, value)
			if Mode in Enable1,Enable0,Disable1,Disable0
				this.XtExtractSourceRadio[Mode] := 1
			if (Mode) {
				this.XtExtractSourceText[Mode] := 1
				this.XtExtractSourceDropDown[Mode] := 1
			}
			if Mode in Show1,Show0,Hide1,Hide0
				this.XtExtractSourceButton[Mode] := 1
		}
	}
	
	XtRefreshSource[Mode := "Enable"]
	{
		set {
			this.SetGuiControlMode(Mode, value)
			if Mode in Enable1,Enable0,Disable1,Disable0
				this.XtRefreshSourceRadio[Mode] := 1
			if (Mode) {
				this.XtRefreshSourceText[Mode] := 1
				this.XtRefreshSourceFromTargetCheckBox[Mode] := 1
				this.XtRefreshSourceButton[Mode] := 1
			}
			if Mode in Enable1,Disable0
			{
				if (this.XtRefreshSourceFromTargetCheckBox) {
					this.XtRefreshSourceFromTargetDropDown[Mode] := 1
				}
			} else if (Mode) {
				this.XtRefreshSourceFromTargetDropDown[Mode] := 1
			}
		}
	}
	
	XtExchangeSource[Mode := "Enable"]
	{
		set {
			this.SetGuiControlMode(Mode, value)
			if Mode in Enable1,Enable0,Disable1,Disable0
				this.XtExchangeSourceRadio[Mode] := 1
			if (Mode) {
				this.XtExchangeSourceText[Mode] := 1
				this.XtExchangeSourceTargetDropDown[Mode] := 1
			}
			if Mode in Show1,Show0,Hide1,Hide0
				this.XtExchangeSourceButton[Mode] := 1
		}
	}
	
	XtSourceLabel[Mode := "Enable"]
	{
		set {
			global XtSourceLabel
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, XtSourceLabel
			}
		}
	}
	
	XtExtractSourceRadio[Mode := "Enable"]
	{
		set {
			global XtExtractSourceRadio
			if (Mode = "Check" and value) {
				Control, Check,,, % "ahk_id " this.HWND.XtExtractSourceRadio
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, XtExtractSourceRadio
				}
			}
		}
	}
	
	XtExtractSourceText[Mode := "Enable"]
	{
		set {
			global XtExtractSourceText
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, XtExtractSourceText
			}
		}
	}
	
	XtExtractSourceDropDown[Mode := "List"]
	{
		get {
			global XtExtractSourceDropDown
			GuiControlGet, Selection,, XtExtractSourceDropDown
			return Selection
		}
		set {
			global XtExtractSourceDropDown
			if (Mode = "List" or Mode = "Raw") {
				if IsObject(value) {
					List := "|"
					for key, val in value {
						List .= "|" val
					}
				} else if (Mode = "Raw") {
					List := value
				} else if (not SubStr(value, 1, 2) = "||") {
					List := "||" value
				}
				GuiControl,, XtExtractSourceDropDown, % List
			} else if (Mode = "Choose") {
				Selection := (value) ? value : 0
				GuiControl, Choose, XtExtractSourceDropDown, % Selection
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, XtExtractSourceDropDown
				}
			}
		}
	}
	
	XtExtractSourceButton[Mode := "Enable"]
	{
		set {
			global XtExtractSourceButton
			this.SetGuiControlMode(Mode, value)
			if Mode in Enable1,Disable0
			{
				PlusMinus := "+"
			} else {
				PlusMinus := "-"
			}
			GuiControl, % PlusMinus "Default", XtExtractSourceButton
			if (Mode) {
				GuiControl, % Mode, XtExtractSourceButton
			}
		}
	}
	
	XtRefreshSourceRadio[Mode := "Enable"]
	{
		set {
			global XtRefreshSourceRadio
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, XtRefreshSourceRadio
			}
		}
	}
	
	
	XtRefreshSourceText[Mode := "Enable"]
	{
		set {
			global XtRefreshSourceText
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, XtRefreshSourceText
			}
		}
	}
	
	XtRefreshSourceFromTargetCheckBox[Mode := "Enable"]
	{
		get {
			global XtRefreshSourceFromTargetCheckBox
			GuiControlGet, CheckState,, XtRefreshSourceFromTargetCheckBox
			return CheckState
		}
		set {
			global XtRefreshSourceFromTargetCheckBox, XRSFTCB
			if (Mode = "Color") {
				FontColor := (value) ? "c" value : ""
				Gui, Font, % FontColor
				GuiControl, Font, XtRefreshSourceFromTargetCheckBox	
			} else if (Mode = "Uncheck" and value) {
				Control, Uncheck,,, % "ahk_id " this.HWND.XtRefreshSourceFromTargetCheckBox
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, XtRefreshSourceFromTargetCheckBox
				}
			}
		}
	}
	
	XtRefreshSourceFromTargetDropDown[Mode := "List"]
	{
		get {
			global XtRefreshSourceFromTargetDropDown
			GuiControlGet, Selection,, XtRefreshSourceFromTargetDropDown
			return Selection
		}
		set {
			global XtRefreshSourceFromTargetDropDown
			if (Mode = "List" or Mode = "Raw") {
				if IsObject(value) {
					for key, val in value {
						List .= "|" val
					}
				} else if (Mode = "Raw") {
					List := value
				} else if (not SubStr(value, 1, 1) = "|") {
					List := "|" value
				}
				GuiControl,, XtRefreshSourceFromTargetDropDown, % List
			} else if (Mode = "Choose") {
				Selection := (value) ? value : 0
				GuiControl, Choose, XtRefreshSourceFromTargetDropDown, % Selection
			} else if (Mode = "Focus") {
				GuiControl, Focus, XtRefreshSourceFromTargetDropDown
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, XtRefreshSourceFromTargetDropDown
				}
			}
		}
	}
	
	XtRefreshSourceButton[Mode := "Enable"]
	{
		set {
			global XtRefreshSourceButton
			 if (Mode = "Focus") {
				GuiControl, Focus, XtRefreshSourceButton
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, XtRefreshSourceButton
				}
			}
		}
	}
	
	XtExchangeSourceRadio[Mode := "Enable"]
	{
		set {
			global XtExchangeSourceRadio
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, XtExchangeSourceRadio
			}
		}
	}
	
	XtExchangeSourceText[Mode := "Enable"]
	{
		set {
			global XtExchangeSourceText
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, XtExchangeSourceText
			}
		}
	}
	
	XtExchangeSourceTargetDropDown[Mode := "List"]
	{
		get {
			global XtExchangeSourceTargetDropDown
			GuiControlGet, Selection,, XtExchangeSourceTargetDropDown
			return Selection
		}
		set {
			global XtExchangeSourceTargetDropDown
			if (Mode = "List" or Mode = "Raw") {
				if IsObject(value) {
					List := "|"
					for key, val in value {
						List .= "|" val
					}
				} else if (Mode = "Raw") {
					List := value
				} else if (not SubStr(value, 1, 2) = "||") {
					List := "||" value
				}
				GuiControl,, XtExchangeSourceTargetDropDown, % List
			} else if (Mode = "Choose") {
				Selection := (value) ? value : 0
				GuiControl, Choose, XtExchangeSourceTargetDropDown, % Selection
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, XtExchangeSourceTargetDropDown
				}
			}
		}
	}
	
	XtExchangeSourceButton[Mode := "Enable"]
	{
		set {
			global XtExchangeSourceButton
			this.SetGuiControlMode(Mode, value)
			if Mode in Enable1,Disable0
			{
				PlusMinus := "+"
			} else {
				PlusMinus := "-"
			}
			GuiControl, % PlusMinus "Default", XtExchangeSourceButton
			if (Mode) {
				GuiControl, % Mode, XtExchangeSourceButton
			}
		}
	}
	
	;* Create translation

	AddGuiElementsToGroupBoxXtTargetLang()
	{
		global XtTargetLangLabel
			, XtTargetLangText
			, XtTargetLangEdit
			, XtTargetLangButton

		Gui, Add, Text, % "xs" this.GroupBoxLabelXs " ys0 r1 vXtTargetLangLabel Disabled"
			, % " " Txt.Get("XtTargetLangGroupBoxLabel") " "
		Gui, Add, Text, % "xs" this.Xs1 " ys" this.Ys1 " w225 r1 vXtTargetLangText Disabled"
			, % Txt.Get("XtTargetLangText")
		Gui, Add, Edit, % "xp231 yp-3 w60 h20 vXtTargetLangEdit gEvent.XtTargetLangEdit Disabled"
		Gui, Add, Button, % "xp70 yp-2 w134 h25 vXtTargetLangButton gEvent.XtTargetLangButton Disabled"
			, % Txt.Get("XtTargetLangButton")
	}
	
	XtTargetLang[Mode := "Enable"]
	{
		set {
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				this.XtTargetLangLabel[Mode] := 1
				this.XtTargetLangText[Mode] := 1
				this.XtTargetLangEdit[Mode] := 1
			}
			if Mode in Enable0,Disable1
			{
				this.XtTargetLangButton[Mode] := 1
			}
		}
	}
	
	XtTargetLangLabel[Mode := "Enable"]
	{
		set {
			global XtTargetLangLabel
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, XtTargetLangLabel
			}
		}
	}
	
	XtTargetLangText[Mode := "Enable"]
	{
		set {
			global XtTargetLangText
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, XtTargetLangText
			}
		}
	}
	
	XtTargetLangEdit[Mode := "Text"]
	{
		get {
			global XtTargetLangEdit
			GuiControlGet, EditText,, XtTargetLangEdit
			return EditText
		}
		set {
			global XtTargetLangEdit
			if (Mode = "Text") {
				GuiControl,, XtTargetLangEdit, % value
			} else {
				this.SetGuiControlMode(Mode, value)
				if (Mode) {
					GuiControl, % Mode, XtTargetLangEdit
				}
			}
		}
	}
	
	XtTargetLangButton[Mode := "Enable"]
	{
		set {
			global XtTargetLangButton
			this.SetGuiControlMode(Mode, value)
			if Mode in Enable1,Disable0
			{
				PlusMinus := "+"
			} else {
				PlusMinus := "-"
			}
			GuiControl, % PlusMinus "Default", XtTargetLangButton
			if (Mode) {
				GuiControl, % Mode, XtTargetLangButton
			}
		}
	}
	
	;* Split / merge XLIFF
	
	AddGuiElementsToGroupBoxXtSplitMerge()
	{
		global XtSplitMergeLabel
			, XtSplitMergeText
			, XtSplitButton
			, XtMergeButton

		Gui, Add, Text, % "xs" this.GroupBoxLabelXs " ys0 r1 vXtSplitMergeLabel Disabled"
			, % " " Txt.Get("XtSplitMergeGroupBoxLabel") " "
		Gui, Add, Text, % "xs" this.Xs1 " ys" this.Ys1 " r1 vXtSplitMergeText Disabled"
			, % Txt.Get("XtSplitMergeText")
		Gui, Add, Button, % "xp-2 yp21 w214 h26 vXtSplitButton gEvent.XtSplitButton Disabled"
			, % Txt.Get("XtSplitButton")
		Gui, Add, Button, % "xp224 yp0 w214 h26 vXtMergeButton gEvent.XtMergeButton Disabled"
			, % Txt.Get("XtMergeButton")
	}
	
	XtSplitMerge[Mode := "Enable"]
	{
		set {
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				this.XtSplitMergeLabel[Mode] := 1
				this.XtSplitMergeText[Mode] := 1
				this.XtSplitButton[Mode] := 1
				this.XtMergeButton[Mode] := 1
			}
		}
	}
	
	XtSplitMergeLabel[Mode := "Enable"]
	{
		set {
			global XtSplitMergeLabel
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, XtSplitMergeLabel
			}
		}
	}
	
	XtSplitMergeText[Mode := "Enable"]
	{
		set {
			global XtSplitMergeText
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, XtSplitMergeText
			}
		}
	}
	
	XtSplitButton[Mode := "Enable"]
	{
		set {
			global XtSplitButton
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, XtSplitButton
			}
		}
	}
	
	XtMergeButton[Mode := "Enable"]
	{
		set {
			global XtMergeButton
			this.SetGuiControlMode(Mode, value)
			if (Mode) {
				GuiControl, % Mode, XtMergeButton
			}
		}
	}
	
	XtReset(All := 0)
	{
		if (All) {
			this.XtFolderEdit := ""
			this.XtXliffDropDown := ""
			this.XtXliff := 0
		}
		this.XtConsistencyText := ""
		this.XtConsistency := 0
		this.XtExtractSourceDropDown["Choose"] := "|" 0
		this.XtExtractSourceDropDown["Raw"] := "|"
		this.XtRefreshSourceFromTargetCheckBox["Uncheck"] := 1
		this.XtExchangeSourceTargetDropDown["Choose"] := "|" 0
		this.XtExchangeSourceTargetDropDown["Raw"] := "|"
		this.XtExtractSourceRadio["Check"] := 1
		this.XtSource := 0
		this.XtTargetLangEdit := ""
		this.XtTargetLang := 0
		this.XtSplitMerge := 0
	}

/*
 * mind: this file is included inside class definition,
 * so don't write double close bracket
 *
}
*/