class XGui
{
	static TabX := 11
		, TabY := 11
		, GroupBoxWidth := 460
		, GroupBoxGap := 10
		, GroupBoxLabelXs := 7
		, Xs1 := 13
		, Ys1 := 24
		, HWND := {}
		, ListViewCol2Width := {X2v: {}, V2x: {}}
		, VerticalScrollBarWidth

	FirstElementX[Adder := 16]
	{
		get {
			return this.TabX + Adder
		}
	}
	FirstElementY[Adder := 40]
	{
		get {
			return this.TabY + Adder
		}
	}
	
	Window()
	{
		global WindowTab
			, ListViewHeader := {}
			, LostFocusControl := {}
			, DialogHwnd := {}
		SysGet, VSBW, 2 ; SM_CXVSCROLL  VerticalScrollBarWidth
		this.VerticalScrollBarWidth := VSBW
		
		Gui, -MaximizeBox
		Gui, Add, Tab3, % "x" this.TabX " y" this.TabY " w484 h534 vWindowTab AltSubmit"
			, % Txt.Get("TabXt") "|" Txt.Get("TabX2v") "|" Txt.Get("TabV2x")
		this.AddGuiElementsToTabXt()
		this.AddGuiElementsToTabX2v()
		this.AddGuiElementsToTabV2x()
		Gui, Show, w504 h556, XLIFFer
	}
	
	#Include %A_LineFile%\..\xgui#tab-xt.ahk
	#Include %A_LineFile%\..\xgui#tab-x2v.ahk
	#Include %A_LineFile%\..\xgui#tab-v2x.ahk
	
	ActiveTab[]
	{
		get {
			global WindowTab
			GuiControlGet, ActiveTab,, WindowTab
			return ActiveTab
		}
		set {
			global WindowTab
			Gui, Show
			if (value = "Xt") {
				value := 1
			} else if (value = "X2v") {
				value := 2
			} else if (value = "V2x") {
				value := 3
			}
			GuiControl, Choose, WindowTab, % value
		}
	}
	
	SetGuiControlMode(ByRef Mode, ByRef value)
	{
		if Mode not in Enable1,Enable0,Disable1,Disable0,Show1,Show0,Hide1,Hide0
		{
			if value in 0,1
			{
				if Mode in Enable,Disable,Show,Hide
				{
					Mode := Mode value
				} else if Mode in Enabled,Disabled
				{
					Mode := SubStr(Mode, 1, -1) value
				} else if (Mode = "Visible") {
					Mode := "Show" value
				} else if (Mode = "Hidden") {
					Mode := "Hide" value
				} else {
					Mode := 0
				}
			}
		}
	}
	
	GetNewTextWidth(NewText)
	{
		static
		local NewTextPos, NewTextPosX, NewTextPosY, NewTextPosW, NewTextPosH
		AddCounter += 1
		Gui, Add, Text, % "x0 y0 r1 Hidden vNewText" AddCounter, % NewText
		GuiControlGet, NewTextPos, Pos, NewText%AddCounter%
		return NewTextPosW
	}
	
	ListViewReplaceDoubles(X)
	{
		global X2vListView, V2xListView
		XListView := X "ListView"
		if (A_DefaultListView != XListView) {
			Gui, ListView, % XListView
		}
		SourceEdit := (X = "X2v" )
			? XGui.X2vSourceLangDataSetEdit
			: XGui.V2xSourceLangEdit
		Loop % LV_GetCount() {
			this.ListViewReplaceDoublesInRow(X, A_Index, SourceEdit)
		}
	}

	ListViewReplaceDoublesInRow(ByRef X, RowNumber, ByRef AddReplaceKey*)
	{
		global X2vListView, V2xListView
		XListView := X "ListView"
		if (A_DefaultListView != XListView) {
			Gui, ListView, % XListView
		}
		LV_GetText(Field1, RowNumber)
		Exclude := XGui[XListView, "Keys", RowNumber]
		for i, key in AddReplaceKey {
			Exclude[key] := 1
		}
		if not Field1 Exclude.HasKey(Field1) {
			LV_GetText(Field2, RowNumber, 2)
			Loop {
				if not Exclude.HasKey(Field2) {
					break
				}
				Field2 .= A_Index
				LoopReplaced := 1
			}
			XGui[XListView, RowNumber] := Field2
			if Field1 or LoopReplaced {
				DoubleInTitle := (X = "X2v")
					? Txt.Get("DoubleVariableDataSetNamesInTitle")
					: Txt.Get("DoubleLanguageCodesInTitle")
				DoubleInText := (X = "X2v")
					? Txt.Get("DoubleVariableDataSetNameInText")
					: Txt.Get("DoubleLanguageCodeInText")
				MsgBox, 8208, % Txt.Get("ReplaceDoublesMsgBoxTitle", {Double: DoubleInTitle})
					, % Txt.Get("ReplaceDoublesMsgBoxText", {Double: DoubleInText})
				LV_Modify(RowNumber, "+Focus +Select")
			}
		}
	}
	
	SourceEditReplaceDouble(X)
	{
		SourceEdit := (X = "X2v")
			? "X2vSourceLangDataSetEdit"
			: "V2xSourceLangEdit"
		SourceEditText := XGui[SourceEdit]
		ChooseRadio := (X = "X2v")
			? "X2vChooseTargetLangRadio"
			: "V2xChooseTargetLangRadio"
		if (X = "V2x") {
			ChosenSourceLang := XGui.V2xSourceLangDataSetDropDown
		}
		if XGui[ChooseRadio] {
			Exclude := (X = "X2v")
				? XGui[X "ListView", "Keys"]
				: XGui[X "ListView", "Keys", ChosenSourceLang]
		} else {
			Exclude := (X = "X2v")
				? Config.XliffTargetLanguageKeys["X2v"]
				: Config.V2xVarDataSetKeys[ChosenSourceLang]
		}
		if not SourceEditText or Exclude.HasKey(SourceEditText) {
			ReplaceWith := (X = "X2v")
				? Config.XliffSourceLanguage["X2v"]
				: XGui.V2xSourceLangDataSetDropDown
			Loop {
				if not Exclude.HasKey(ReplaceWith) {
					break
				}
				ReplaceWith .= A_Index
				LoopReplaced := 1
			}
			XGui[SourceEdit] := ReplaceWith
			if SourceEditText or LoopReplaced {
				DoubleInTitle := (X = "X2v")
					? Txt.Get("DoubleVariableDataSetNamesInTitle")
					: Txt.Get("DoubleLanguageCodesInTitle")
				DoubleInText := (X = "X2v")
					? Txt.Get("DoubleVariableDataSetNameInText")
					: Txt.Get("DoubleLanguageCodeInText")
				MsgBox, 8208, % Txt.Get("ReplaceDoublesMsgBoxTitle", {Double: DoubleInTitle})
					, % Txt.Get("ReplaceDoublesMsgBoxText", {Double: DoubleInText})
				XGui[SourceEdit, "Focus"] := 1
			}
		}
	}
	
	XLReset()
	{
		this.XtReset()
		this.X2vReset()
	}
	
	Reset()
	{
		this.XtReset(1)
		this.X2vReset(1)
		this.V2xReset(1)
	}
}

;* OnMessage-Function after Edit loosing focus

On_ControlLostFocus(W, L) {
	global LostFocusControl
	static LastHw := 0x000000
	Critical 1000
	SetFormat, IntegerFast, h
	if (LastHw == 0x000000)	{
		LastHw := L
		return
	}
	if (LastHw != L) {
		if (LostFocusControl.HasKey(LastHw)) {
			FunctionName := LostFocusControl[LastHw]
			%FunctionName%()
		}
		LastHw := L
	}
	return
}

;* OnMessage-Function to fix ListView-Style

On_ListViewHeaderOnOff(W, L, M, H) {
	global ListViewHeader
	static HeaderGrey := 0x808080
		, NM_CUSTOMDRAW := -12
		, CDRF_DODEFAULT := 0x00000000
		, CDRF_NEWFONT := 0x00000002
		, CDRF_NOTIFYITEMDRAW := 0x00000020
		, CDDS_PREPAINT := 0x00000001
		, CDDS_ITEMPREPAINT := 0x00010001
		, OHWND := 0
		, OMsg := (2 * A_PtrSize)
		, ODrawStage := OMsg + 4 + (A_PtrSize - 4)
		, OHDC := ODrawStage + 4 + (A_PtrSize - 4)
		, OItemSpec := OHDC + 16 + A_PtrSize
	Critical 1000
	HWND := NumGet(L + 0, OHWND, "Ptr")
	if (ListViewHeader.HasKey(HWND)) {
		if (ListViewHeader[HWND]) {
			Code := (~NumGet(L+0,8))+1
			if Code in 306,326
				return true
		} else if (NumGet(L + 0, OMsg, "Int") = NM_CUSTOMDRAW) {
			DrawStage := NumGet(L + 0, ODrawStage, "UInt")
			if (DrawStage = CDDS_ITEMPREPAINT) {
				HDC := NumGet(L + 0, OHDC, "Ptr")
				DllCall("Gdi32.dll\SetTextColor", "Ptr", HDC, "UInt", HeaderGrey)
				return CDRF_NEWFONT
			}
			if (DrawStage = CDDS_PREPAINT) {
				return CDRF_NOTIFYITEMDRAW
			}
			return CDRF_DODEFAULT
		}
	}
}

;* Function to add Icons to Buttons

GuiButtonIcon(Handle, File, Index := 1, Options := "")
{
	RegExMatch(Options, "i)w\K\d+", W), (W="") ? W := 16 :
	RegExMatch(Options, "i)h\K\d+", H), (H="") ? H := 16 :
	RegExMatch(Options, "i)s\K\d+", S), S ? W := H := S :
	RegExMatch(Options, "i)l\K\d+", L), (L="") ? L := 0 :
	RegExMatch(Options, "i)t\K\d+", T), (T="") ? T := 0 :
	RegExMatch(Options, "i)r\K\d+", R), (R="") ? R := 0 :
	RegExMatch(Options, "i)b\K\d+", B), (B="") ? B := 0 :
	RegExMatch(Options, "i)a\K\d+", A), (A="") ? A := 4 :
	Psz := A_PtrSize = "" ? 4 : A_PtrSize, DW := "UInt", Ptr := A_PtrSize = "" ? DW : "Ptr"
	VarSetCapacity( button_il, 20 + Psz, 0 )
	NumPut( normal_il := DllCall( "ImageList_Create", DW, W, DW, H, DW, 0x21, DW, 1, DW, 1 ), button_il, 0, Ptr )	; Width & Height
	NumPut( L, button_il, 0 + Psz, DW )		; Left Margin
	NumPut( T, button_il, 4 + Psz, DW )		; Top Margin
	NumPut( R, button_il, 8 + Psz, DW )		; Right Margin
	NumPut( B, button_il, 12 + Psz, DW )	; Bottom Margin	
	NumPut( A, button_il, 16 + Psz, DW )	; Alignment
	SendMessage, BCM_SETIMAGELIST := 5634, 0, &button_il,, AHK_ID %Handle%
	return IL_Add( normal_il, File, Index )
}