<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns="urn:oasis:names:tc:xliff:document:1.2"
	xmlns:xlf="urn:oasis:names:tc:xliff:document:1.2"
	exclude-result-prefixes="xlf">

	<xsl:output indent="yes"/>

	<!-- Stylesheet for merged xliff -->

	<xsl:param name="targetLanguage"/>

	<xsl:param name="targetToSource" select="false()"/>

	<xsl:template match="*">
		<xsl:copy>
			<xsl:copy-of select="@*"/>
			<xsl:apply-templates/>
		</xsl:copy>
	</xsl:template>

	<xsl:template match="xlf:file">
		<xsl:if test="@target-language = $targetLanguage">
			<xsl:copy>
				<xsl:choose>
					<xsl:when test="$targetToSource">
						<xsl:attribute name="source-language">
							<xsl:value-of select="@target-language"/>
						</xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:copy-of select="@source-language"/>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:copy-of select="@original|@datatype"/>
				<xsl:apply-templates/>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<xsl:template match="xlf:trans-unit">
		<xsl:copy>
			<xsl:copy-of select="@id"/>
			<xsl:choose>
				<xsl:when test="$targetToSource">
					<source>
						<xsl:copy-of select="xlf:target/node()"/>
					</source>
				</xsl:when>
				<xsl:otherwise>
					<xsl:copy-of select="xlf:source"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:copy>
	</xsl:template>

</xsl:stylesheet>