<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns="urn:oasis:names:tc:xliff:document:1.2"
	xmlns:xlf="urn:oasis:names:tc:xliff:document:1.2"
	exclude-result-prefixes="xlf">

	<xsl:output indent="yes"/>

	<!-- Stylesheet for merged xliff -->

	<xsl:param name="fromTargetLanguage" select="false()"/>

	<xsl:template match="*">
		<xsl:copy>
			<xsl:copy-of select="@*"/>
			<xsl:apply-templates/>
		</xsl:copy>
	</xsl:template>

	<xsl:template match="xlf:trans-unit">
		<xsl:variable name="transUnitId" select="@id"/>
		<xsl:copy>
			<xsl:copy-of select="@id"/>
			<xsl:choose>
				<xsl:when test="$fromTargetLanguage">
					<xsl:copy-of select="/xlf:xliff/xlf:file[@target-language = $fromTargetLanguage]/xlf:body/xlf:trans-unit[@id = $transUnitId]/xlf:source"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:copy-of select="/xlf:xliff/xlf:file[not(@target-language)]/xlf:body/xlf:trans-unit[@id = $transUnitId]/xlf:source"/>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:copy-of select="xlf:target"/>
		</xsl:copy>
	</xsl:template>

</xsl:stylesheet>